
// Bookmark Tabs
//-----------------------------------------------
//ǩ
tabutils._bookmarkTabs = function() {
	gBrowser.bookmarkTab = function(aTabs) {
		if (!("length" in aTabs))
		aTabs = [aTabs];

		if (aTabs.length > 1) {
			let tabURIs = TU_getPref("extensions.tabutils.bookmarkWithHistory", false) 
				? Array.map(aTabs, function(aTab) 
					[aTab.linkedBrowser.currentURI, 
						[{name: 'bookmarkProperties/tabState', value: tabutils._ss.getTabState(aTab)}]
					]) 
				: Array.map(aTabs, function(aTab) aTab.linkedBrowser.currentURI);
			PlacesUIUtils.showBookmarkDialog(
				{	action: "add",
					type: "folder",
					URIList: tabURIs,
					hiddenRows: ["description"]
				}, window);
		}
		else
			PlacesCommandHook.bookmarkPage(aTabs[0].linkedBrowser, PlacesUtils.bookmarksMenuFolderId, true);
	};

	TU_hookCode("PlacesCommandHook.bookmarkPage",
		[/(?=.*(createItem|PlacesCreateBookmarkTransaction).*)/, 
			function() {
				var annos = [descAnno];
				if (TU_getPref("extensions.tabutils.bookmarkWithHistory", false)) {
					let tab = gBrowser.mTabs[gBrowser.browsers.indexOf(aBrowser)];
					if (tab)
						annos.push({name: "bookmarkProperties/tabState", value: tabutils._ss.getTabState(tab)});
				}
			}
		],
		[/.*(createItem|PlacesCreateBookmarkTransaction).*/, function(s) s.replace("[descAnno]", "annos")]  // Bug 575955 [Fx13]
	);

	TU_hookCode("PlacesCommandHook.bookmarkCurrentPages",
		["this.uniqueCurrentPages", (
			function() {
				TU_getPref("extensions.tabutils.bookmarkAllWithHistory", true) 
				? Array.map(gBrowser.allTabs, function(aTab) 
					[aTab.linkedBrowser.currentURI, 
						[{name: 'bookmarkProperties/tabState', value: tabutils._ss.getTabState(aTab)}]
					]) 
				: Array.map(gBrowser.allTabs, function(aTab) aTab.linkedBrowser.currentURI);
			}
		).toString().replace(/^.*{|}$/g, "")],
		["pages.length > 1", "true"]
	);

	//Highlight bookmarks with history
	TU_hookCode("PlacesViewBase.prototype._createMenuItemForPlacesNode", /(?=return element;)/, 
		function() {
			if (aPlacesNode.itemId != -1 && PlacesUtils.annotations.itemHasAnnotation(aPlacesNode.itemId, "bookmarkProperties/tabState"))
				element.setAttribute("history", true);
		}
	);

	TU_hookCode("PlacesToolbar.prototype._insertNewItem", "}", 
		function() {
			if (aChild.itemId != -1 && PlacesUtils.annotations.itemHasAnnotation(aChild.itemId, "bookmarkProperties/tabState"))
				button.setAttribute("history", true);
		}
	);

	//Open bookmarks with history
	TU_hookCode("gBrowser.loadOneTab",
		["{", "var lastArg = Object(arguments[arguments.length - 1]);"],
		[/(?=return tab;)/, 
			function() {
				if (lastArg.itemId && PlacesUtils.annotations.itemHasAnnotation(lastArg.itemId, "bookmarkProperties/tabState")) {
					tab.linkedBrowser.stop();
					tabutils._ss.setTabState(tab, PlacesUtils.annotations.getItemAnnotation(lastArg.itemId, "bookmarkProperties/tabState"));
				}
			}
		]
	);

	TU_hookCode("gBrowser.loadTabs",
		["{", "var lastArg = Object(arguments[arguments.length - 1]), aItemIds = lastArg.itemIds;"],
		[/(\w+) = .*addTab.*\[(.*)\].*/g, 
			function(s, s1, s2) (
				function() {
					$0
					if (aItemIds && aItemIds[$2] && PlacesUtils.annotations.itemHasAnnotation(aItemIds[$2], "bookmarkProperties/tabState")) {
						$1.linkedBrowser.stop();
						tabutils._ss.setTabState($1, PlacesUtils.annotations.getItemAnnotation(aItemIds[$2], "bookmarkProperties/tabState"));
					}
				}
			).toString().replace(/^.*{|}$/g, "").replace("$0", s).replace("$1", s1, "g").replace("$2", s2, "g")
		]
	);
};
