// Main context menu
//-----------------------------------------------
//Ҽ˵
tabutils._mainContextMenu = function() {
	nsContextMenu.prototype.isLinkSelected = function() {
		var focusedWindow = document.commandDispatcher.focusedWindow;
		if (!focusedWindow || focusedWindow == window)
			focusedWindow = window.content;

		var links = focusedWindow.document.links;
		var selection = focusedWindow.getSelection();
		if (!links || !selection)
			return false;

		this.linkURLs = [];
		for (let link of links) {
			if (selection.containsNode(link, true) && this.linkURLs.indexOf(link.href) == -1)
				this.linkURLs.push(link.href);
		}

		var item = document.getElementById("context-openselectedlinksintab");
		item.setAttribute("label", item.getAttribute("label").replace(/\d*(?=])/, this.linkURLs.length));

		return this.linkURLs.length > 1;
	};

	nsContextMenu.prototype.openSelectedLinksInTab = function() {
		this.linkURLs.forEach(
			function(aURL) openNewTabWith(aURL, this.target.ownerDocument, null, null, false)
			, this
		);
	};

	//TU_hookCode("nsContextMenu.prototype.initOpenItems", /.*openlinkincurrent.*/, function(s) s.replace("onPlainTextLink", "shouldShow"));
	TU_hookCode("nsContextMenu.prototype.initOpenItems", "}", 
		function() {
			this.showItem("context-openselectedlinksintab", this.isLinkSelected());
		}
	);
};

// Tab context menu
//-----------------------------------------------
//ǩҳҼ˵
tabutils._tabContextMenu = function() {
	function $() {
		return document.getElementById.apply(document, arguments);
	}

	var tabContextMenu = gBrowser.tabContextMenu;
	tabContextMenu.insertBefore($("context_closeOtherTabs"), $("context_closeTab").nextSibling);

	Array.slice($("tabContextMenu-template").childNodes).forEach(
		function(aItem, aIndex, aItems) {
			var refNode;
			switch (true) {
				case aItem.getAttribute("insertafter") != "":
					refNode = tabContextMenu.getElementsByAttribute("id", aItem.getAttribute("insertafter"))[0];
					refNode = refNode && refNode.nextSibling;
					break;
				case aItem.getAttribute("insertbefore") != "":
					refNode = tabContextMenu.getElementsByAttribute("id", aItem.getAttribute("insertbefore"))[0];
					break;
				default:
					refNode = aItems[aIndex - 1] && aItems[aIndex - 1].nextSibling;
					break;
			}
			tabContextMenu.insertBefore(aItem, refNode);
		}
	);

	tabutils.addEventListener(tabContextMenu.parentNode, "popupshowing", 
		function(event) {
			if (event.target != tabContextMenu)
				return;

			for (let item of tabContextMenu.childNodes)
				item.hidden = false;
		}
		, true
	);

	tabutils.addEventListener(tabContextMenu.parentNode, "popupshowing", 
		function(event) {
			if (event.target != tabContextMenu)
				return;

			gBrowser.mContextTabs = gBrowser.contextTabsOf(gBrowser.mContextTab);

			var mselected = gBrowser.mContextTab.hasAttribute("multiselected");
			var grouponly = gBrowser.mContextTabs.every(
				function(aTab) 
					aTab.hasAttribute("group") && aTab.getAttribute("group-counter") != 1
			);
			//    var disableCollapse = grouponly && gBrowser.mContextTabs.every(function(aTab) aTab.getAttribute("group-collapsed") == "true");
			//    var disableExpand = grouponly && gBrowser.mContextTabs.every(function(aTab) aTab.getAttribute("group-collapsed") != "true");

			var contextTab = gBrowser.mContextTab;
			$("context_collapseGroup").setAttribute("disabled", contextTab.getAttribute("group-collapsed") == "true");
			$("context_expandGroup").setAttribute("disabled", contextTab.getAttribute("group-collapsed") != "true");
			$("context_splitGroup").setAttribute("disabled", contextTab.getAttribute("group-collapsed") == "true" 
				|| contextTab.hasAttribute("group-first") 
				|| contextTab.hasAttribute("group-last"));

			var lastVisibleItem = null;
			for (let item of tabContextMenu.childNodes) {
				switch (true) {
					case item.localName == "menuseparator":
						item.hidden = !lastVisibleItem || lastVisibleItem.localName == "menuseparator";
						break;
					case mselected && (item.getAttribute("multiselected") == "false" 
						|| item.getAttribute("multiselected") == ""):
					case !mselected && item.getAttribute("multiselected") == "true":
					case !grouponly && item.getAttribute("grouponly") == "true":
						item.hidden = true;
						break;
				}

				if (!item.hidden && !item.collapsed)
					lastVisibleItem = item;
			}
			if (lastVisibleItem && lastVisibleItem.localName == "menuseparator")
				lastVisibleItem.hidden = true;

			var item = $("context_readTab");
			var checked = gBrowser.mContextTabs.every(
				function(aTab) 
					aTab.getAttribute("unread") != "true"
			);
			item.setAttribute("label", checked ? item.getAttribute("label_checked") : item.getAttribute("label_unchecked"));
			item.setAttribute("checked", checked);
			item.setAttribute("disabled", gBrowser.mContextTabs.every(
				function(aTab) aTab.selected)
			);

			[
				["context_protectTab", ["protected"]],
				["context_lockTab", ["locked"]],
				["context_faviconizeTab", ["faviconized"]]
			].forEach(
				function([aId, aAttrs]) {
					$(aId).setAttribute("checked", gBrowser.mContextTabs.every(
						function(aTab) 
							aAttrs.every(
								function(aAttr) 
									aTab.hasAttribute(aAttr)
							)
					));
				}
			);

			var autoProtect = TU_getPref("extensions.tabutils.pinTab.autoProtect", false);
			var autoLock = TU_getPref("extensions.tabutils.pinTab.autoLock", false);
			var disableProtect = autoProtect && gBrowser.mContextTabs.every(
				function(aTab) 
					aTab.pinned && !aTab.hasAttribute("protected")
			);
			var disableLock = autoLock && gBrowser.mContextTabs.every(
				function(aTab) 
					aTab.pinned && !aTab.hasAttribute("locked")
			);

			if (disableProtect) $("context_protectTab").setAttribute("checked", true);
			if (disableLock) $("context_lockTab").setAttribute("checked", true);

			$("context_closeTab").setAttribute("disabled", $("context_protectTab").getAttribute("checked") == "true");
			$("context_protectTab").setAttribute("disabled", disableProtect);
			$("context_lockTab").setAttribute("disabled", disableLock);

			var disableLeft = gBrowser.leftTabsOf(gBrowser.mContextTabs).length == 0;
			var disableRight = gBrowser.rightTabsOf(gBrowser.mContextTabs).length == 0;
			var disableOther = gBrowser.otherTabsOf(gBrowser.mContextTabs).length == 0;

			$("context_closeLeftTabs").setAttribute("disabled", disableLeft);
			$("context_closeRightTabs").setAttribute("disabled", disableRight);
			$("context_closeOtherTabs").setAttribute("disabled", disableOther);
			$("context_closeDuplicateTabs").setAttribute("disabled", disableOther);
			$("context_closeSimilarTabs").setAttribute("disabled", disableOther);

			var selectedTabs = gBrowser.selectedTabs;
			$("context_groupTab").setAttribute("disabled", selectedTabs.length <= 1);
			$("context_selectTab").setAttribute("checked", mselected);
			$("context_unselectAllTabs").setAttribute("disabled", selectedTabs.length == 0);

			$("context_openTabInWindow").collapsed = !$("context_moveToWindow").collapsed;
			$("context_mergeWindow").setAttribute("disabled", 
				Services.wm.getZOrderDOMWindowEnumerator("navigator:browser", false).getNext() == window
			);

			$("context_mergeGroup").hidden = $("context_tabViewMenu").hidden;
			$("context_mergeGroup").setAttribute("disabled", 
				!Array.some(gBrowser.mTabs, 
					function(aTab) 
						aTab.hidden
				)
			);
		}
		, false
	);

	tabutils.populateWindowMenu = function populateWindowMenu(aPopup, aExcludePopup) {
		while (aPopup.lastChild && aPopup.lastChild.localName != "menuseparator")
			aPopup.removeChild(aPopup.lastChild);

		var winEnum = Services.wm.getEnumerator("navigator:browser");
		while (winEnum.hasMoreElements()) {
			var win = winEnum.getNext();
			var m = document.createElement("menuitem");
			m.setAttribute("class", "menuitem-iconic bookmark-item menuitem-with-favicon");
			m.setAttribute("label", win.gBrowser.mCurrentTab.label);
			m.setAttribute("image", win.gBrowser.mCurrentTab.image);
			m.setAttribute("acceltext", "[" + win.gBrowser.mTabs.length + "]");
			m.setAttribute("disabled", win == window || aExcludePopup && !win.toolbar.visible);
			m.window = win;
			aPopup.appendChild(m);
		}
	};

	TabView.populateGroupMenu = function(aPopup, aExcludeEmpty) {
		while (aPopup.lastChild && aPopup.lastChild.localName != "menuseparator")
			aPopup.removeChild(aPopup.lastChild);

		if (!this._window && !Array.some(gBrowser.mTabs, function(aTab) aTab.hidden))
			return;

		let self = this;
		this._initFrame(
			function() {
				let activeGroupItem = self._window.GroupItems.getActiveGroupItem();
				self._window.GroupItems.groupItems.forEach(
					function(groupItem) {
						if (!groupItem.hidden && (groupItem.getChildren().length > 0 || !aExcludeEmpty && groupItem.getTitle().length > 0)) {
							let activeTab = groupItem.getActiveTab() || groupItem.getChild(0);
							let m = document.createElement("menuitem");
							m.setAttribute("class", "menuitem-iconic bookmark-item menuitem-with-favicon");
							m.setAttribute("label", activeTab && activeTab.tab.label);
							m.setAttribute("image", activeTab && activeTab.tab.image);
							m.setAttribute("acceltext", groupItem.getTitle() + "[" + groupItem.getChildren().length + "]");
							m.setAttribute("disabled", groupItem == activeGroupItem);
							m.value = groupItem;
							aPopup.appendChild(m);
						}
					}
				);
			}
		);
	};

	TabView.moveTabsTo = function(aTabs, aGroupItem) {
		if (!aGroupItem.isAGroupItem) {
			TabView.moveTabTo(aGroupItem.tab, null);
			aGroupItem = aGroupItem.parent;
		}
		aTabs.forEach(
			function(aTab) TabView.moveTabTo(aTab, aGroupItem.id)
		);
		gBrowser.updateCurrentBrowser(true);
	};

	TabView.mergeGroup = function(aGroupItem) {
		if (aGroupItem.isAGroupItem) {
			this._window.GroupItems.newTab({});

			let activeGroupItem = this._window.GroupItems.getActiveGroupItem();
			if (activeGroupItem != aGroupItem)
				aGroupItem.getChildren().slice().forEach(
					function(tabItem) 
						TabView.moveTabTo(tabItem.tab, activeGroupItem.id)
				);
		}
		else {
			this._window.GroupItems.newTab(aGroupItem);
		}
		gBrowser.updateCurrentBrowser(true);
	};

	TabView.selectGroup = function(aGroupItem) {
		if (!aGroupItem)
			return;

		if (aGroupItem.isAGroupItem) {
			let activeTab = aGroupItem.getActiveTab() || aGroupItem.getChild(0);
			if (activeTab)
				gBrowser.selectedTab = activeTab.tab;
		}
		else
			gBrowser.selectedTab = aGroupItem.tab;
	};

	var button = $("nav-bar")._getToolbarItem("tabview-button");
	if (button && !button.hasChildNodes()) {
		let popup = button.appendChild(document.createElement("menupopup"));
		popup.setAttribute("onpopupshowing", "TabView.populateGroupMenu(event.target, true);");
		popup.setAttribute("oncommand", "TabView.selectGroup(event.originalTarget.value);");
		popup.setAttribute("position", "after_end");
		button.setAttribute("type", "menu-button");

		let item = popup.appendChild(document.createElement("menuitem"));
		item.setAttribute("label", $("context_tabViewNewGroup").getAttribute("label"));
		item.setAttribute("command", "cmd_newGroup");
		popup.appendChild(document.createElement("menuseparator"));
	}
};
