
// Multi Tab handler
//-----------------------------------------------
tabutils._multiTabHandler = function() {

	//ѡǩҳ
	gBrowser.isNormalTab = function isNormalTab(aTab) {
		return !aTab.pinned && !aTab.hidden && !aTab.closing;
	};

	gBrowser.__defineGetter__("allTabs", 
		function() {
			let tabs = Array.filter(this.mTabs, this.isNormalTab);
			return tabs.length > 0 ? tabs : (this.visibleTabs || this.mTabs);
		}
	);

	gBrowser.__defineGetter__("selectedTabs", 
		function() {
			return Array.filter(this.mTabs, function(aTab) aTab.hasAttribute("multiselected"));
		}
	);

	gBrowser.__defineSetter__("selectedTabs", 
		function(val) {
			Array.forEach(this.mTabs, function(aTab) aTab.removeAttribute("multiselected"));
			Array.forEach(val, function(aTab) {
				if (aTab.boxObject.width > 0) {
					if (aTab.getAttribute("group-collapsed") == "true" && aTab.getAttribute("group-counter") > 1) {
						let tabs = this.siblingTabsOf(aTab);
						tabs.forEach(function(aTab) aTab.setAttribute("multiselected", true));
					}
					aTab.setAttribute("multiselected", true);
				}
			}, this);
			this._lastClickedTab = null;
			return val;
		}
	);

	gBrowser.contextTabsOf = function contextTabsOf(aTab) {
		return aTab.hasAttribute("multiselected") ? this.selectedTabs :
			aTab.getAttribute("group-collapsed") == "true" || aTab.mOverTwisty ? this.siblingTabsOf(aTab) : [aTab];
	};

	gBrowser.selectTab = function selectTab(aTab, aForce) {
		if (aForce == null)
			aForce = !aTab.hasAttribute("multiselected");

		if (aTab.getAttribute("group-collapsed") == "true" && aTab.getAttribute("group-counter") > 1) {
			let tabs = this.siblingTabsOf(aTab);
			if (aForce)
				tabs.forEach(function(aTab) aTab.setAttribute("multiselected", true));
			else
				tabs.forEach(function(aTab) aTab.removeAttribute("multiselected"));
		}
		aForce ? aTab.setAttribute("multiselected", true) : aTab.removeAttribute("multiselected");
		this._lastClickedTab = aTab;
	};

	gBrowser.selectTabs = function selectTabs(aTab, aKeepSelection) {
		var bTab = this._lastClickedTab || this.mCurrentTab;
		var [start, end] = aTab._tPos < bTab._tPos ? [aTab._tPos, bTab._tPos] : [bTab._tPos, aTab._tPos];
		this.selectedTabs = Array.slice(this.mTabs, start, end + 1)
			.concat(aKeepSelection ? this.selectedTabs : []);
		this._lastClickedTab = bTab;
	};

	gBrowser.selectAllTabs = function() {
		var allTabs = this.allTabs;
		this.selectedTabs = this.selectedTabs.map(function(aTab) aTab._tPos).join() ==
			allTabs.map(function(aTab) aTab._tPos).join() ? (this.visibleTabs || this.mTabs) : allTabs;
	};

	TU_hookCode("gBrowser.onTabSelect", "}", 
		function() {
			if (!aTab.hasAttribute("multiselected"))
				this.selectedTabs = [];
		}
	);

	TU_hookCode("gBrowser.onTabHide", "}", 
		function() {
			aTab.removeAttribute("multiselected");
		}
	);

	TU_hookCode("gBrowser.onStackCollapsed", "}", 
		function() {
			let tabs = this.siblingTabsOf(aTab);
			if (!tabs.every(function(aTab) aTab.hasAttribute("multiselected")))
				tabs.forEach(function(aTab) aTab.removeAttribute("multiselected"));
		}
	);

	//  var tabContextMenu = gBrowser.tabContextMenu;
	//  tabContextMenu.setAttribute("oncommand", "gBrowser.selectedTabs = [];");

	///Ҳ//ظ/Ʊǩҳ
	gBrowser.leftTabsOf = function leftTabsOf(aTabs) {
		if (!("length" in aTabs))
			aTabs = [aTabs];

		return Array.slice(this.mTabs, 0, aTabs[0]._tPos).filter(this.isNormalTab);
	};

	gBrowser.rightTabsOf = function rightTabsOf(aTabs) {
		if (!("length" in aTabs))
			aTabs = [aTabs];

		return Array.slice(this.mTabs, aTabs[aTabs.length - 1]._tPos + 1).filter(this.isNormalTab);
	};

	gBrowser.otherTabsOf = function otherTabsOf(aTabs) {
		if (!("length" in aTabs))
			aTabs = [aTabs];

		return Array.filter(this.mTabs, function(aTab) this.isNormalTab(aTab) && Array.indexOf(aTabs, aTab) == -1, this);
	};

	gBrowser.duplicateTabsOf = function duplicateTabsOf(aTabs) {
		if (!("length" in aTabs))
			aTabs = [aTabs];

		return Array.filter(this.mTabs, 
		function(aTab) 
			this.isNormalTab(aTab) && Array.some(aTabs, 
				function(bTab) {
					return aTab.linkedBrowser.currentURI.spec == bTab.linkedBrowser.currentURI.spec;
				}
			)
		, this);
	};

	gBrowser.similarTabsOf = function similarTabsOf(aTabs) {
		if (!("length" in aTabs))
			aTabs = [aTabs];

		return Array.filter(this.mTabs, 
			function(aTab) 
				this.isNormalTab(aTab) && Array.some(aTabs, 
					function(bTab) {
						try {
							return aTab.linkedBrowser.currentURI.host == bTab.linkedBrowser.currentURI.host;
						}
						catch (e) {
							return aTab.linkedBrowser.currentURI.spec == bTab.linkedBrowser.currentURI.spec;
						}
					}
				)
			, this);
	};

	gBrowser.uniqueTabsOf = function uniqueTabsOf(aTabs) {
		if (!("length" in aTabs))
			aTabs = [aTabs];

		var seenURIs = {};
		return Array.reduce(aTabs, 
			function(aTabs, aTab) {
				var uri = aTab.linkedBrowser.currentURI.spec;
				if (!(uri in seenURIs)) {
					seenURIs[uri] = true;
					aTabs.push(aTab);
				}
				return aTabs;
			}
			, []);
	};

	//رնǩҳ
	TU_hookCode("gBrowser.warnAboutClosingTabs", /\w+(?= <= 1)/, "($& = arguments[1] ? arguments[1].length : $&)");
	gBrowser.removeTabsBut = function removeTabsBut(aTabs, bTabs) {
		aTabs = aTabs ? "length" in aTabs ? aTabs : [aTabs] : [];
		bTabs = bTabs ? "length" in bTabs ? bTabs : [bTabs] : [];

		if (bTabs.length > 0)
			aTabs = Array.filter(aTabs, function(aTab) Array.indexOf(bTabs, aTab) == -1);

		if (aTabs.length == 0)
			return;

		if (aTabs.length == 1)
			return this.removeTab(aTabs[0], {animate: true});
			
		//quick hack for version fix... will cleanup later:
		let version = parseFloat(Services.appinfo.version);
		let warnResult;
		if (version >= 24.0) {
			warnResult = this.warnAboutClosingTabs(this.closingTabsEnum.OTHER, aTabs);
		} else {
			warnResult = this.warnAboutClosingTabs(true, aTabs);
		}

		if (warnResult) {
			if (Array.indexOf(aTabs, this.mCurrentTab) > -1)
				this.selectedTab = bTabs[0] || aTabs[0];

			let count = 0;
			for (let i = aTabs.length - 1; i >= 0; i--) {
				this.removeTab(aTabs[i]);
				if (!aTabs[i].parentNode)
					count++;
			}
			this._lastClosedTabsCount = count;
		}
	};

	TU_hookCode("undoCloseTab", /.*ss.undoCloseTab.*/, "for (let i = aIndex == null ? gBrowser._lastClosedTabsCount || 1 : 1; i > 0; i--) $&;");

	gBrowser.closeLeftTabs = function(aTab) this.removeTabsBut(this.leftTabsOf(aTab), aTab);
	gBrowser.closeRightTabs = function(aTab) this.removeTabsBut(this.rightTabsOf(aTab), aTab);
	gBrowser.closeOtherTabs = function(aTab) this.removeTabsBut(this.otherTabsOf(aTab), aTab);
	gBrowser.closeDuplicateTabs = function(aTab) this.removeTabsBut(this.duplicateTabsOf(aTab), aTab);
	gBrowser.closeSimilarTabs = function(aTab) this.removeTabsBut(this.similarTabsOf(aTab), aTab);
	gBrowser.closeAllTabs = function() this.removeTabsBut(this.allTabs);
	gBrowser.closeAllDuplicateTabs = function() this.removeTabsBut(this.allTabs, this.uniqueTabsOf(this.allTabs));

	//ҷǩҳ
	gBrowser.gatherTabs = function gatherTabs(aTabs, aTab, aSuppressTabMove) {
		let index = 0;
		if (aTab) {
			index = aTabs.indexOf(aTab);
			if (index == -1) {
				while (++index < aTabs.length && aTabs[index]._tPos < aTab._tPos);
				aTabs.splice(index, 0, aTab);
			}
		}

		for (let i = index - 1; i >= 0; i--) {
			aTabs[i]._suppressTabMove = aSuppressTabMove;
			this.moveTabBefore(aTabs[i], aTabs[i + 1]);
			delete aTabs[i]._suppressTabMove;
		}

		for (let i = index + 1; i < aTabs.length; i++) {
			aTabs[i]._suppressTabMove = aSuppressTabMove;
			this.moveTabAfter(aTabs[i], aTabs[i - 1]);
			delete aTabs[i]._suppressTabMove;
		}
	};

	gBrowser.moveTabBefore = function moveTabBefore(aTab, bTab) {
		this.moveTabTo(aTab, aTab._tPos < bTab._tPos ? bTab._tPos - 1 : bTab._tPos);
	};

	gBrowser.moveTabAfter = function moveTabAfter(aTab, bTab) {
		this.moveTabTo(aTab, aTab._tPos > bTab._tPos ? bTab._tPos + 1 : bTab._tPos);
	};

	TU_hookCode("gBrowser.onTabMove", "{", 
		function() {
			if (aTab._suppressTabMove)
				return;
		}
	);

	tabutils.addEventListener(gBrowser.mTabContainer, "dragstart", 
		function(event) {
			if (event.target.localName == "tab") {
				let draggedTab = event.target;
				let draggedTabs = gBrowser.contextTabsOf(draggedTab);
				draggedTabs.splice(draggedTabs.indexOf(draggedTab), 1);
				draggedTabs.unshift(draggedTab);

				let dt = event.dataTransfer;
				draggedTabs.forEach(
					function(aTab, aIndex) {
						dt.mozSetDataAt(TAB_DROP_TYPE, aTab, aIndex);
						dt.mozSetDataAt("text/x-moz-text-internal", aTab.linkedBrowser.currentURI.spec, aIndex);
					}
				);
			}
		}
	, true);

	TU_hookCode("gBrowser.mTabContainer._setEffectAllowedForDataTransfer",
		["dt.mozItemCount > 1", "false"]
	);

	//TODO: This code moves multi-selected tabs?
	TU_hookCode("gBrowser.onTabMove", "}", 
		function() {
			if (aTab.hasAttribute("multiselected")) {
				let selectedTabs = this.selectedTabs;
				if (selectedTabs[selectedTabs.length - 1]._tPos - selectedTabs[0]._tPos >= selectedTabs.length) {
					let tabs = selectedTabs.filter(function(aTab) aTab.boxObject.width > 0);
					tabs.splice(tabs.indexOf(aTab), 1);

					let index = 0;
					let oldPos = aTab._tPos > event.detail ? event.detail - 0.5 : event.detail + 0.5;
					while (index < tabs.length && tabs[index]._tPos < oldPos)
						index++;
					tabs.splice(index, 0, aTab);

					setTimeout(
						function(self) {
							self.selectedTabs = [];
							self.gatherTabs(tabs, aTab);
							self.selectedTabs = selectedTabs;
						}
					, 0, this);
				}
			}
		}
	);

	TU_hookCode("gBrowser.moveTabTo", // Bug 822068 [Fx20]
		["this.mCurrentTab._selected = false;", "let wasFocused = (document.activeElement == this.mCurrentTab);$&"],
		["this.mCurrentTab._selected = true;", "$&;if (wasFocused) this.mCurrentTab.focus();"]
	);

	["moveTabBackward", "moveTabForward", "moveTabToStart", "moveTabToEnd"].forEach(
		function(aMethod) {
			TU_hookCode.call(gBrowser, aMethod, "this.mCurrentTab.focus();", "");
		}
	);

	TU_hookCode("gBrowser.moveTabBackward", "this.mCurrentTab._tPos", (
		function() { // Bug 656222 [Fx20]
			(function (self) {
				let tab = self.mCurrentTab.previousSibling;
				while (tab && tab.boxObject.width == 0)
					tab = tab.previousSibling;
				return tab ? tab._tPos + 1 : 0;
			})(this)
		}
		).toString().replace(/^.*{|}$/g, "")
	);

	TU_hookCode("gBrowser.moveTabForward", "this.mCurrentTab._tPos", (
		function() {
			(function (self) {
				let tab = self.mCurrentTab.nextSibling;
				while (tab && tab.boxObject.width == 0)
					tab = tab.nextSibling;
				return tab ? tab._tPos - 1 : self.mTabs.length;
			})(this)
		}
		).toString().replace(/^.*{|}$/g, "")
	);

	//Protect/Lock/Faviconize/Pin All Tabs
	[
		["gBrowser.unreadTab", ["unread"]],
		["gBrowser.protectTab", ["protected"]],
		["gBrowser.lockTab", ["locked"]],
		["gBrowser.freezeTab", ["protected", "locked"]],
		["gBrowser.faviconizeTab", ["faviconized"]],
		["gBrowser.pinTab", ["pinned"]],
		["gBrowser.autoReloadTab", ["autoReload"]]
	].forEach(
		function([aFuncName, aAttrs]) {
			TU_hookCode(aFuncName, "{", (
				function() {
					if ("length" in arguments[0]) {
						let aTabs = Array.slice(arguments[0]);
						if (aForce == null)
							aForce = !aTabs.every(function(aTab) aAttrs.every(function(aAttr) aTab.hasAttribute(aAttr)));

						let func = arguments.callee, args = Array.slice(arguments, 2);
						aTabs.forEach(
							function(aTab) {
								func.apply(this, Array.concat(aTab, aForce, args));
							}
							, this
						);
						return;
					}
				}
			).toString().replace(/^.*{|}$/g, "").replace("aAttrs", aAttrs.toSource()));
		}
	);

	TU_hookCode("gBrowser.reloadTab", /.*reload\b.*/, "try {$&} catch (e) {}");

	gBrowser.moveTabToWindow = function moveTabToWindow(aTabs, aWindow) {
		if (!aWindow) {
			aTabs[0].selectedTabs = aTabs;
			return this.replaceTabWithWindow(aTabs[0]);
		}

		if (aWindow.gPrivateBrowsingUI.privateBrowsingEnabled != gPrivateBrowsingUI.privateBrowsingEnabled) // Bug 799001 [Fx20]
			return;

		let bTabs = [];
		aTabs.forEach(
			function(aTab) {
				let bTab = this.addTab();
				bTab.linkedBrowser.stop();
				bTab.linkedBrowser.docShell;
				this.swapBrowsersAndCloseOther(bTab, aTab);
				bTabs.push(bTab);
			}
			, aWindow.gBrowser
		);

		if (bTabs.length > 1 && aWindow.TU_getPref("extensions.tabutils.autoStack", false))
			aWindow.gBrowser.groupTabs(bTabs);

		return aWindow;
	};

	TU_hookCode("gBrowser.swapBrowsersAndCloseOther", /(?=.*_beginRemoveTab.*)/, 
		function() {
			if (
				[gBrowserInit.onLoad, gBrowserInit._delayedStartup].indexOf(arguments.callee.caller) > -1 ||  // Bug 756313 [Fx19]
				["onxbldrop", "_handleTabDrop"].indexOf(arguments.callee.caller.name) > -1
			) {
				let selectedTabs = aOtherTab.selectedTabs || remoteBrowser.contextTabsOf(aOtherTab);
				if (selectedTabs.length > 1) {
					this.swapBrowsersAndCloseOther(aOurTab, selectedTabs.shift());

					let bTabs = [aOurTab];
					selectedTabs.forEach(
						function(aTab, aIndex) {
							let bTab = this.addTab();
							bTab.linkedBrowser.stop();
							bTab.linkedBrowser.docShell;
							this.moveTabTo(bTab, aOurTab._tPos + aIndex + 1);
							this.swapBrowsersAndCloseOther(bTab, aTab);
							bTabs.push(bTab);
						}
						, this
					);

					if (bTabs.length < this.mTabs.length && TU_getPref("extensions.tabutils.autoStack", false))
						this.groupTabs(bTabs);

					return;
				}
			}
		}
	);

	[
		["context_reloadTab", "gBrowser.mContextTabs.forEach(gBrowser.reloadTab, gBrowser);"],
		["context_reloadAllTabs", "gBrowser.allTabs.forEach(gBrowser.reloadTab, gBrowser);"],
		["context_pinTab", "gBrowser.pinTab(gBrowser.mContextTabs, true);"],
		["context_unpinTab", "gBrowser.pinTab(gBrowser.mContextTabs, false);"],
		["context_openTabInWindow", "gBrowser.moveTabToWindow(gBrowser.mContextTabs);"],
		["context_bookmarkTab", "gBrowser.bookmarkTab(gBrowser.mContextTabs);"],
		["context_closeTab", "gBrowser.removeTabsBut(gBrowser.mContextTabs);"],
		["context_closeOtherTabs", "gBrowser.removeTabsBut(gBrowser.allTabs, gBrowser.mContextTabs);"]
	].forEach(
		function([aId, aCommand]) {
			var item = document.getElementById(aId);
			if (item) {
				item.setAttribute("oncommand", aCommand);
				item.setAttribute("multiselected", "any");
			}
		}
	);
};
