
// Open UI Link in Tab
//-----------------------------------------------
tabutils._openUILinkInTab = function() {

	//ҳ
	TU_hookCode("BrowserGoHome", "browser.tabs.loadBookmarksInBackground", "extensions.tabutils.loadHomepageInBackground");

	//ַس
	TU_hookCode("gURLBar.handleCommand",
		[/((aTriggeringEvent)\s*&&\s*(aTriggeringEvent.altKey))(?![\s\S]*\1)/, 
			"let (newTabPref = TU_getPref('extensions.tabutils.openUrlInTab', true)) ($1 || newTabPref) && !(($2 ? $3 : false) && newTabPref && TU_getPref('extensions.tabutils.invertAlt', true))"],
		[/(?=.*openUILinkIn.*)/, 
			function() {
				params.inBackground = TU_getPref('extensions.tabutils.loadUrlInBackground', false);
				params.disallowInheritPrincipal = !mayInheritPrincipal;
				params.event = aTriggeringEvent || {};
			}
		],
		[/.*loadURIWithFlags.*(?=[\s\S]*(let params[\s\S]*openUILinkIn.*))/, function(s, s1) s1.replace("where", '"current"')],
		["aTriggeringEvent.preventDefault();", ""],
		["aTriggeringEvent.stopPropagation();", ""]
	);
	TU_hookCode("openLinkIn", /(?=let uriObj)/, "w.gURLBar.handleRevert();");

	//س
	if (BrowserSearch.searchBar)
		TU_hookCode("BrowserSearch.searchBar.handleSearchCommand",
			[/(\(aEvent && aEvent.altKey\)) \^ (newTabPref)/, 
				"($1 || $2) && !($1 && $2 && TU_getPref('extensions.tabutils.invertAlt', true)) && !isTabEmpty(gBrowser.selectedTab)"],
			[/"tab"/, "TU_getPref('extensions.tabutils.loadSearchInBackground', false) ? 'background' : 'foreground'"]
		);

	//Ҽǩ
	TU_hookCode("BookmarksEventHandler.onClick",
		["aEvent.button == 2", 
			"$& && (aEvent.ctrlKey || aEvent.altKey || aEvent.metaKey || !TU_getPref('extensions.tabutils.rightClickBookmarks', 0))"],
		["aEvent.button == 1", "aEvent.button > 0"],
		["}", "if (aEvent.button == 2) aEvent.preventDefault();"]
	);
	TU_hookCode("checkForMiddleClick",
		["event.button == 1", 
			"($& || event.button == 2 && !event.ctrlKey && !event.altKey && !event.metaKey && TU_getPref('extensions.tabutils.rightClickBookmarks', 0))"],
		[/.*closeMenus.*/, "{$&;event.preventDefault();}"]
	);
	TU_hookCode("whereToOpenLink", "e.button == 1", "e.button > 0");

	//ֲ˵
	TU_hookCode("BookmarksEventHandler.onClick", /.*hidePopup.*/, "if (!(TU_getPref('extensions.tabutils.middleClickBookmarks', 0) & 4)) $&");
	TU_hookCode("checkForMiddleClick", /.*closeMenus.*/, "if (!(TU_getPref('extensions.tabutils.middleClickBookmarks', 0) & 4)) $&");

	TU_hookCode.call(
		document.getElementById("PopupAutoCompleteRichResult"), "onPopupClick",
		["aEvent.button == 2", 
			"$& && (aEvent.ctrlKey || aEvent.altKey || aEvent.metaKey || !TU_getPref('extensions.tabutils.rightClickBookmarks', 0))"],
		[/.*closePopup[\s\S]*handleEscape.*/, 
			"if (aEvent.button && TU_getPref('extensions.tabutils.middleClickBookmarks', 0) & 4) gBrowser.userTypedValue = null; else {$&}"]
	);

	tabutils.addEventListener(
		gURLBar.parentNode, "blur", 
		function(event) {
			if (gURLBar.popupOpen && TU_getPref('extensions.tabutils.middleClickBookmarks', 0) & 4) {
				gURLBar._dontBlur = true;
				setTimeout(
					function() {
						gURLBar.mIgnoreFocus = true;
						gURLBar.focus();
						gURLBar.mIgnoreFocus = false;
						gURLBar._dontBlur = false;
					}
				, 0);
			}
		}
	, true);
};

// Open Link in Tab
//-----------------------------------------------

tabutils._openLinkInTab = function() {

	//ǿ±ǩҳ
	TU_hookCode("contentAreaClick"
		, /if[^{}]*event.button == 0[^{}]*{([^{}]|{[^{}]*}|{([^{}]|{[^{}]*})*})*(?=})/, "$&" + (
		function() {
			if (tabutils.gOpenLinkInTab && !href.startsWith("javascript:")) {
				openNewTabWith(href, linkNode.ownerDocument, null, event, false);
				event.preventDefault();
				return;
			}
		}).toString().replace(/^.*{|}$/g, "")
	);

	TU_hookCode("nsBrowserAccess.prototype.openURI", /(?=switch \(aWhere\))/, 
		function() {
			if (tabutils.gOpenLinkInTab && !isExternal)
				aWhere = Ci.nsIBrowserDOMWindow.OPEN_NEWTAB;
		}
	);

	//ǿں̨±ǩҳ
	TU_hookCode("gBrowser.loadOneTab", /(?=var owner)/, "bgLoad = bgLoad && !tabutils.gLoadAllInForeground || tabutils.gLoadAllInBackground;");
	TU_hookCode("gBrowser.loadTabs", /(?=var owner)/, "aLoadInBackground = aLoadInBackground && !tabutils.gLoadAllInForeground || tabutils.gLoadAllInBackground;");

	//ǿ±ǩҳⲿ
	TU_hookCode("contentAreaClick"
		, /if[^{}]*event.button == 0[^{}]*{([^{}]|{[^{}]*}|{([^{}]|{[^{}]*})*})*(?=})/, "$&" + (
		function() {
			if (/^(https?|ftp)/.test(href) && TU_getPref("extensions.tabutils.openExternalInTab", false)) {
				let ourDomain = tabutils.getDomainFromURI(linkNode.ownerDocument.documentURIObject);
				let otherDomain = tabutils.getDomainFromURI(href);
				if (ourDomain != otherDomain) {
					openNewTabWith(href, linkNode.ownerDocument, null, event, false);
					event.preventDefault();
					return;
				}
			}
		}).toString().replace(/^.*{|}$/g, "")
	);

	//
	TU_hookCode("nsBrowserAccess.prototype.openURI", 
		'"browser.tabs.loadDivertedInBackground"', 'isExternal ? "extensions.tabutils.loadForeignInBackground" : $&', "g");

	//
	TU_hookCode("contentAreaClick", /.*handleLinkClick.*/g, 
		"if (event.button || event.ctrlKey || event.altKey || event.shiftKey || event.metaKey) $&");
	TU_hookCode("handleLinkClick", 'where == "current"', "false");

	//м
	TU_hookCode("openNewTabWith", "aEvent.shiftKey", 
		"$& ^ (aEvent.button == 1 && TU_getPref('extensions.tabutils.middleClickLinks', 0) & 2) > 0");

	//Ҽ
	TU_hookCode("contentAreaClick",
		["event.button == 2", 
			"$& && (event.ctrlKey || event.altKey || event.metaKey || !TU_getPref('extensions.tabutils.rightClickLinks', 0))"]
	);
	TU_hookCode("handleLinkClick",
		["event.button == 2", "false"],
		["event.preventDefault();", 
			'document.getElementById("contentAreaContextMenu").hidePopup();$&', 'g']
	);
	TU_hookCode("openNewTabWith", "aEvent.button == 1", "aEvent.button > 0");

	//ҷ
	TU_hookCode("handleDroppedLink", /.*loadURI.*/, 
		function(s) (
			function() {
				{
					let event = arguments[0];
					switch (true) {
						case /\.(xpi|user\.js)$/.test(uri):
						case !TU_getPref("extensions.tabutils.dragAndGo", true):
							$0;
							break;
						case event.ctrlKey != TU_getPref("extensions.tabutils.invertDrag", false):
							BrowserSearch.loadSearch(name || url, true);
							break;
						default:
							openNewTabWith(uri, null, postData.value, event, true, event.target.ownerDocument.documentURIObject);
							break;
					}
				}
			}
		).toString().replace(/^.*{|}$/g, "").replace("$0", s)
	);

	for (let b of gBrowser.browsers) {
		b.droppedLinkHandler = handleDroppedLink;
	}

	//±ǩҳʱ̳ʷ
	TU_hookCode("gBrowser.loadOneTab",
		["{", 
			function() {
				var currentTab = this.mCurrentTab;
			}
		],
		[/(?=return tab;)/, 
			function() {
				if (aReferrerURI && TU_getPref("extensions.tabutils.openLinkWithHistory", false)) {
					let currentHistory = currentTab.linkedBrowser.sessionHistory;
					let newHistory = tab.linkedBrowser.sessionHistory.QueryInterface(Ci.nsISHistoryInternal);
					for (let i = 0; i <= currentHistory.index; i++) {
						newHistory.addEntry(currentHistory.getEntryAtIndex(i, false), true);
					}
				}
			}
		]
	);
};
