
// Restart Tab
//-----------------------------------------------
//ǩҳ
tabutils._restartTab = function() {
	gBrowser.restartTab = function restartTab(aTab) {
		if (aTab.hasAttribute("pending")) // Bug 817947 [Fx20]
			return;

		var tabState = tabutils._ss.getTabState(aTab);
		var bTab = this.addTab();
		bTab.collapsed = true;
		bTab.linkedBrowser.stop();
		bTab.linkedBrowser.docShell;
		this.swapBrowsersAndCloseOther(aTab, bTab);
		tabutils._ss.setTabState(aTab, tabState);
	};

	gBrowser.autoRestartTab = function autoRestartTab(aTab) {
		if (aTab.selected || aTab._restartTimer || ["busy", "pending"].some(function(aAttr) aTab.hasAttribute(aAttr)))
			return;

		let restartAfter = TU_getPref("extensions.tabutils.restartAfter", 0);
		if (restartAfter == 0)
			return;

		let spec = aTab.linkedBrowser.currentURI.spec;
		if (isBlankPageURL(spec) || tabutils.getURIsForTag("norestart").some(function(aURI) spec.startsWith(aURI.spec)))
			return;

		aTab._restartTimer = setTimeout(
			function(aTab) {
				if (aTab && aTab.parentNode)
					gBrowser.restartTab(aTab);
			}
			, restartAfter * 60 * 1000, aTab);
	};

	TU_hookCode("gBrowser.onTabSelect", "}", 
		function() {
			if (aTab._restartTimer) {
				clearTimeout(aTab._restartTimer);
				aTab._restartTimer = null;
			}
		}
	);

	TU_hookCode("gBrowser.onTabBlur", "}", 
		function() {
			this.autoRestartTab(aTab);
		}
	);

	TU_hookCode("gBrowser.mTabProgressListener", /(?=var location)/, 
		function() {
			if (this.mTab._restartTimer) {
				clearTimeout(this.mTab._restartTimer);
				this.mTab._restartTimer = null;
			}
			this.mTabBrowser.autoRestartTab(this.mTab);
		}
	);
};

// reload every...
//-----------------------------------------------
//Զˢ±ǩҳ
tabutils._reloadEvery = function() {
	gBrowser.autoReloadTab = function autoReloadTab(aTab, aForce, aInterval, aRestoring) {
		if (aTab.hasAttribute("autoReload") && aForce != true) {
			tabutils.removeAttribute(aTab, "autoReload");
			tabutils.deleteTabValue(aTab, "reloadInterval");
			if (!aRestoring && !gPrivateBrowsingUI.privateBrowsingEnabled) {
				PlacesUtils.tagging.untagURI(aTab.linkedBrowser.currentURI, ["autoReload"]);
			}
			this.mTabContainer.adjustTabstrip(aTab.pinned);

			clearTimeout(aTab._reloadTimer);
		}
		else if (!aTab.hasAttribute("autoReload") && aForce == null || aForce == true) {
			tabutils.setAttribute(aTab, "autoReload", true);
			aTab._reloadInterval = aInterval || aTab._reloadInterval || TU_getPref("extensions.tabutils.reloadInterval", 10);
			TU_setPref("extensions.tabutils.reloadInterval", aTab._reloadInterval);
			tabutils.setTabValue(aTab, "reloadInterval", aTab._reloadInterval);

			if (!aRestoring && !gPrivateBrowsingUI.privateBrowsingEnabled && TU_getPref("extensions.tabutils.autoEnableAutoReload", true)) {
				PlacesUtils.tagging.tagURI(aTab.linkedBrowser.currentURI, ["autoReload"]);

				let itemId = PlacesUtils.getItemIdForTaggedURI(aTab.linkedBrowser.currentURI, "autoReload");
				if (itemId != -1)
					PlacesUtils.setAnnotationsForItem(itemId, [{name: "reloadInterval", value: aTab._reloadInterval}]);
			}
			this.mTabContainer.adjustTabstrip(aTab.pinned);

			clearTimeout(aTab._reloadTimer);
			aTab._reloadTimer = setTimeout(
				function(aTab) {
					if (aTab && aTab.parentNode)
					gBrowser.reloadTab(aTab);
				}
				, aTab._reloadInterval * 1000, aTab);
		}
	};

	TU_hookCode("gBrowser.onTabRestoring", "}", 
		function() {
			this.autoReloadTab(aTab, ss.getTabValue(aTab, "autoReload") == "true", ss.getTabValue(aTab, "reloadInterval"), true);
		}
	);

	gBrowser.autoAutoReloadTab = function autoAutoReloadTab(aTab, aURI, aTags) {
		if (!aTab.hasAttribute("autoReload") && aTags.indexOf("autoReload") > -1 && TU_getPref("extensions.tabutils.autoEnableAutoReload", true)) {
			let itemId = PlacesUtils.getItemIdForTaggedURI(aURI, "autoReload"), reloadInterval;
			if (PlacesUtils.annotations.itemHasAnnotation(itemId, "reloadInterval")) {
				reloadInterval = PlacesUtils.annotations.getItemAnnotation(itemId, "reloadInterval");
			}
			this.autoReloadTab(aTab, true, reloadInterval, true);
		}
	};

	TU_hookCode("gBrowser.onTabOpen", "}", "this.autoAutoReloadTab(aTab, uri, tags);");
	TU_hookCode("gBrowser.onLocationChange", "}", "this.autoAutoReloadTab(aTab, uri, tags);");

	TU_hookCode("gBrowser.mTabProgressListener", /(?=var location)/, 
		function() {
			if (this.mTab.hasAttribute("autoReload")) {
				clearTimeout(this.mTab._reloadTimer);
				this.mTab._reloadTimer = setTimeout(
					function(aTab) {
					if (aTab && aTab.parentNode)
						gBrowser.reloadTab(aTab);
					}
					, this.mTab._reloadInterval * 1000, this.mTab);
			}
		}
	);

	gBrowser.updateAutoReloadPopup = function updateAutoReloadPopup(aPopup) {
		aPopup.value = gBrowser.mContextTab._reloadInterval || TU_getPref("extensions.tabutils.reloadInterval", 10);
		aPopup.label = (
			function() {
				var m = parseInt(aPopup.value / 60), s = aPopup.value % 60;
				return (m > 1 ? m + " " + aPopup.getAttribute("minutes") 
					: m > 0 ? m + " " + aPopup.getAttribute("minute") : "")
					+ (m > 0 && s > 0 ? " " : "")
					+ (s > 1 ? s + " " + aPopup.getAttribute("seconds") : s > 0 ? s + " " + aPopup.getAttribute("second") : "");
			}
		)();

		var itemEnable = aPopup.getElementsByAttribute("anonid", "enable")[0];
		itemEnable.setAttribute("checked", gBrowser.mContextTabs.every(function(aTab) aTab.hasAttribute("autoReload")));
		itemEnable.setAttribute("label", itemEnable.getAttribute("text") + ": " + aPopup.label);

		var itemCustom = aPopup.getElementsByAttribute("anonid", "custom")[0];
		var item = aPopup.getElementsByAttribute("value", aPopup.value)[0];
		if (item) {
			item.setAttribute("checked", true);
		}
		else {
			itemCustom.setAttribute("checked", true);
			itemCustom.setAttribute("value", aPopup.value);
		}

		if (itemCustom.hasAttribute("checked")) {
			itemCustom.setAttribute("label", itemCustom.getAttribute("text") + ": " + aPopup.label);
		}
		else {
			itemCustom.setAttribute("label", itemCustom.getAttribute("text") + PlacesUIUtils.ellipsis);
		}
	};
};
