// Protect and Lock Tab
//-----------------------------------------------
//ǩҳǩҳǩҳ
tabutils._protectAndLockTab = function() {
	gBrowser.protectTab = function protectTab(aTab, aForce, aRestoring) {
		if (aTab.hasAttribute("protected") && aForce != true) {
			tabutils.removeAttribute(aTab, "protected");
			if (!aRestoring && !gPrivateBrowsingUI.privateBrowsingEnabled) {
				PlacesUtils.tagging.untagURI(aTab.linkedBrowser.currentURI, ["protected"]);
			}
			this.mTabContainer.adjustTabstrip(aTab.pinned);
		}
		else if (!aTab.hasAttribute("protected") && aForce != false) {
			tabutils.setAttribute(aTab, "protected", true);
			if (!aRestoring && !gPrivateBrowsingUI.privateBrowsingEnabled && TU_getPref("extensions.tabutils.autoProtect", true)) {
				PlacesUtils.tagging.tagURI(aTab.linkedBrowser.currentURI, ["protected"]);
			}
			this.mTabContainer.adjustTabstrip(aTab.pinned);
		}
	};

	gBrowser.lockTab = function lockTab(aTab, aForce, aRestoring) {
		if (aTab.hasAttribute("locked") && aForce != true) {
			tabutils.removeAttribute(aTab, "locked");
			if (!aRestoring && !gPrivateBrowsingUI.privateBrowsingEnabled) {
				PlacesUtils.tagging.untagURI(aTab.linkedBrowser.currentURI, ["locked"]);
			}
		}
		else if (!aTab.hasAttribute("locked") && aForce != false) {
			tabutils.setAttribute(aTab, "locked", true);
			if (!aRestoring && !gPrivateBrowsingUI.privateBrowsingEnabled && TU_getPref("extensions.tabutils.autoLock", true)) {
				PlacesUtils.tagging.tagURI(aTab.linkedBrowser.currentURI, ["locked"]);
			}
		}
	};

	gBrowser.freezeTab = function freezeTab(aTab, aForce) {
		if ((!aTab.hasAttribute("protected") || !aTab.hasAttribute("locked")) && aForce != false) {
			this.protectTab(aTab, true);
			this.lockTab(aTab, true);
		}
		else if ((aTab.hasAttribute("protected") || aTab.hasAttribute("locked")) && aForce != true) {
			this.protectTab(aTab, false);
			this.lockTab(aTab, false);
		}
	};

	TU_hookCode("gBrowser.onTabRestoring", "}", 
		function() {
			this.protectTab(aTab, ss.getTabValue(aTab, "protected") == "true", true);
			this.lockTab(aTab, ss.getTabValue(aTab, "locked") == "true", true);
		}
	);

	gBrowser.autoProtectTab = function autoProtectTab(aTab, aURI, aTags) {
		if (!aTab.hasAttribute("protected") && aTags.indexOf("protected") > -1 && TU_getPref("extensions.tabutils.autoProtect", true))
			this.protectTab(aTab, true, true);
	};

	gBrowser.autoLockTab = function autoLockTab(aTab, aURI, aTags) {
		if (aURI.spec != "about:blank" && TU_getPref("extensions.tabutils.autoLock", true)) {
			let locked = tabutils.getURIsForTag("locked").some(function(bURI) aURI.spec.startsWith(bURI.spec));
			this.lockTab(aTab, locked, true);
		}
	};

	TU_hookCode("gBrowser.onTabOpen", "}", "this.autoProtectTab(aTab, uri, tags);this.autoLockTab(aTab, uri, tags);");
	TU_hookCode("gBrowser.onLocationChange", "}", "this.autoProtectTab(aTab, uri, tags);this.autoLockTab(aTab, uri, tags);");

	TU_hookCode("gBrowser.removeTab", "{", 
		function() {
			if (aTab.hasAttribute("protected") || aTab.pinned && TU_getPref("extensions.tabutils.pinTab.autoProtect", false))
				return;
		}
	);
	TU_hookCode("gBrowser.createTooltip", /(tab|tn).mOverCloseButton/, "$& && !$1.hasAttribute('protected')");

	TU_hookCode("gBrowser.loadURI", "{", 
		function() {
			let locked = this.mCurrentTab.hasAttribute("locked")
				|| this.mCurrentTab.pinned && TU_getPref("extensions.tabutils.pinTab.autoLock", false);
			if (locked && !aURI.startsWith("javascript:"))
				return this.loadOneTab(aURI, aReferrerURI, aCharset, null, null, false);
		}
	);

	TU_hookCode("gBrowser.loadURIWithFlags", "{", 
		function() {
			let locked = this.mCurrentTab.hasAttribute("locked")
				|| this.mCurrentTab.pinned && TU_getPref("extensions.tabutils.pinTab.autoLock", false);
			if (locked && !aURI.startsWith("javascript:"))
				return this.loadOneTab(aURI, aReferrerURI, aCharset, aPostData, null, 
					aFlags & Ci.nsIWebNavigation.LOAD_FLAGS_ALLOW_THIRD_PARTY_FIXUP);
		}
	);

	TU_hookCode("contentAreaClick", /if[^{}]*event.button == 0[^{}]*{([^{}]|{[^{}]*}|{([^{}]|{[^{}]*})*})*(?=})/, "$&" + (
		function() {
			let locked = gBrowser.mCurrentTab.hasAttribute("locked")
				|| gBrowser.mCurrentTab.pinned && TU_getPref("extensions.tabutils.pinTab.autoLock", false);
			if (locked && !href.startsWith("javascript:")) {
				openNewTabWith(href, linkNode.ownerDocument, null, event, false);
				event.preventDefault();
				return;
			}
		}
	).toString().replace(/^.*{|}$/g, ""));
};

// Faviconize Tab
//-----------------------------------------------
//ͼ껯ǩҳ
tabutils._faviconizeTab = function() {
	gBrowser.faviconizeTab = function faviconizeTab(aTab, aForce, aRestoring) {
		if (aTab.hasAttribute("faviconized") && aForce != true) {
			tabutils.removeAttribute(aTab, "faviconized");
			tabutils.setTabValue(aTab, "faviconized", false); //for pinned but not iconified tabs
			if (!aRestoring && !gPrivateBrowsingUI.privateBrowsingEnabled) {
				PlacesUtils.tagging.untagURI(aTab.linkedBrowser.currentURI, ["faviconized"]);
			}
			this.mTabContainer.adjustTabstrip(aTab.pinned);
		}
		else if (!aTab.hasAttribute("faviconized") && aForce != false) {
			tabutils.setAttribute(aTab, "faviconized", true);
			if (!aRestoring && !gPrivateBrowsingUI.privateBrowsingEnabled && TU_getPref("extensions.tabutils.autoFaviconize", true)) {
				PlacesUtils.tagging.tagURI(aTab.linkedBrowser.currentURI, ["faviconized"]);
			}
			this.mTabContainer.adjustTabstrip(aTab.pinned);
		}
	};

	TU_hookCode("gBrowser.onTabRestoring", "}", 
		function() {
			this.faviconizeTab(aTab, ss.getTabValue(aTab, "faviconized") == "true" ||
				ss.getTabValue(aTab, "faviconized") != "false" && tabutils.getTabValue(aTab, "pinned") == "true", true);
		}
	);

	gBrowser.autoFaviconizeTab = function autoFaviconizeTab(aTab, aURI, aTags) {
		if (this.mTabContainer.orient == "horizontal" && !aTab.pinned 
			&& aURI.spec != "about:blank" && TU_getPref("extensions.tabutils.autoFaviconize", true)
		) {
			let faviconized = tabutils.getURIsForTag("faviconized").some(function(bURI) aURI.spec.startsWith(bURI.spec));
			this.faviconizeTab(aTab, faviconized, true);
		}
	};

	TU_hookCode("gBrowser.onTabOpen", "}", "this.autoFaviconizeTab(aTab, uri, tags);");
	TU_hookCode("gBrowser.onLocationChange", "}", "this.autoFaviconizeTab(aTab, uri, tags);");
};

// Pin Tab (no code?)
//-----------------------------------------------
//̶ǩҳ
tabutils._pinTab = function() {
};

// Rename Tab
//-----------------------------------------------
//ǩҳ
tabutils._renameTab = function() {
	gBrowser.renameTab = function renameTab(aTab, aTitle, aRestoring) {
		if (aTab.getAttribute("title") == aTitle)
			return;

		if (aTitle)
			tabutils.setAttribute(aTab, "title", aTitle);
		else
			tabutils.removeAttribute(aTab, "title");

		if (!aRestoring && !gPrivateBrowsingUI.privateBrowsingEnabled && TU_getPref("extensions.tabutils.autoRename", true)) {
			PlacesUtils.tagging[aTitle ? "tagURI" : "untagURI"](aTab.linkedBrowser.currentURI, ["autoRename"]);

			let itemId = PlacesUtils.getItemIdForTaggedURI(aTab.linkedBrowser.currentURI, "autoRename");
			if (itemId != -1)
				PlacesUtils.bookmarks.setItemTitle(itemId, aTitle);
		}

		this.setTabTitle(aTab);
	}

	TU_hookCode("gBrowser.onTabRestoring", "}", 
		function() {
			tabutils.restoreAttribute(aTab, "title");
			if (aTab.hasAttribute("title")) {
				aTab.label = aTab.getAttribute("title");
				aTab.crop = "end";
			}
		}
	);

	gBrowser.autoRenameTab = function autoRenameTab(aTab, aURI, aTags) {
		if (!aTab.hasAttribute("title") && aTags.indexOf("autoRename") > -1 && TU_getPref("extensions.tabutils.autoRename", true)) {
			let itemId = PlacesUtils.getItemIdForTaggedURI(aURI, "autoRename");
			this.renameTab(aTab, PlacesUtils.bookmarks.getItemTitle(itemId), true);
		}
	};

	TU_hookCode("gBrowser.onTabOpen", "}", "this.autoRenameTab(aTab, uri, tags);");
	TU_hookCode("gBrowser.onLocationChange", "}", "this.autoRenameTab(aTab, uri, tags);");

	TU_hookCode("gBrowser.setTabTitle", "browser.contentTitle", "aTab.getAttribute('title') || $&");
	TU_hookCode("gBrowser.getWindowTitleForBrowser", "aBrowser.contentTitle", 
		"this.mTabs[this.browsers.indexOf(aBrowser)].getAttribute('title') || $&");

	//Bookmark title as Tab title
	TU_hookCode("gBrowser.loadOneTab",
		["{", "var lastArg = Object(arguments[arguments.length - 1]);"],
		[/(?=return tab;)/, 
			function() {
				if (lastArg.title && TU_getPref("extensions.tabutils.titleAsBookmark", false))
					tab.setAttribute("title", lastArg.title);
			}
		]
	);

	TU_hookCode("gBrowser.loadTabs",
		["{", "var lastArg = Object(arguments[arguments.length - 1]), aTitles = TU_getPref('extensions.tabutils.titleAsBookmark', false) ? lastArg.titles : null;"],
		[/(\w+) = .*addTab.*\[(.*)\].*/g, 
			function(s, s1, s2) (
				function() {
					$0
					if (aTitles && aTitles[$2])
						$1.setAttribute("title", aTitles[$2]);
				}
			).toString().replace(/^.*{|}$/g, "").replace("$0", s).replace("$1", s1, "g").replace("$2", s2, "g")
		]
	);
};
