// Tab Opening Options
//-----------------------------------------------
tabutils._tabOpeningOptions = function() {

	//½ǩҳʱпհױǩҳ
	TU_hookCode("gBrowser.addTab",
		[/if \(arguments.length == 2[^{}]*\) {[^{}]*}/, "$&" + (
			function() {
				if (!isBlankPageURL(aURI)) {
					let t = aFromExternal && isTabEmpty(this.selectedTab) && this.selectedTab || this.getBlankTab();
					if (t) {
						let b = this.getBrowserForTab(t);
						return t;
					}
				}
			}
		).toString().replace(/^.*{|}$/g, "")],
		[/(?=return t;)/, 
			gBrowser.addTab.toString()
				.match(/var (uriIsAboutBlank).*|if \(!uriIsAboutBlank\) {([^{}]|{[^{}]*})*}/g).join("\n")] // Bug 716108 [Fx22]
	);

	gBrowser.getBlankTab = function getBlankTab() {
		var reuseBlank = TU_getPref("extensions.tabutils.reuseBlank", 1);
		return 
			reuseBlank & 1 && this.isBlankTab(this.mCurrentTab) ? this.mCurrentTab :
				reuseBlank & 2 && this.isBlankTab(this.mTabContainer.lastChild) ? this.mTabContainer.lastChild :
					reuseBlank & 4 ? this.getFirstBlankTabBut() : null;
	};

	gBrowser.getFirstBlankTabBut = function getFirstBlankTabBut(aTab) {
		for (let tab of this.mTabs) {
			if (tab != aTab && this.isBlankTab(tab))
				return tab;
		}
	};

	gBrowser.isBlankTab = function isBlankTab(aTab) {
		return this.isBlankBrowser(aTab.linkedBrowser)
			&& ["busy", "pending", "ontap"].every(function(aAttr) !aTab.hasAttribute(aAttr))
			&& !aTab.hidden && !aTab.closing;
	};

	gBrowser.isBlankBrowser = function isBlankBrowser(aBrowser) {
		return (!aBrowser.currentURI || isBlankPageURL(aBrowser.currentURI.spec))
			&& (!aBrowser.sessionHistory || aBrowser.sessionHistory.count < 2)
			&& (!aBrowser.webProgress || !aBrowser.webProgress.isLoadingDocument);
	};
	TU_hookCode("isBlankPageURL", 'aURL == "about:blank"', "gInitialPages.indexOf(aURL) > -1");

	//Զرշ򿪵Ŀհױǩҳ
	TU_hookCode("gBrowser.mTabProgressListener", /(?=var location)/, 
		function() {
			if (aWebProgress.DOMWindow.document.documentURI == "about:blank"
				&& aRequest.QueryInterface(nsIChannel).URI.spec != "about:blank"
				&& aStatus == 0
				&& TU_getPref("extensions.tabutils.removeUnintentionalBlank", true)
			) {
				let win = aWebProgress.DOMWindow;
				win._closeTimer = win.setTimeout(
					function(self) {
						self.mTabBrowser.isBlankTab(self.mTab) && self.mTabBrowser.removeTab(self.mTab);
					}
					, 250, this);
			}
		}
	);

	//ڵǰǩҳҲ±ǩҳ
	//򿪺̨ǩʱԭ˳
	TU_hookCode("gBrowser.addTab",
		[/\S*insertRelatedAfterCurrent\S*(?=\))/, "false"],
		[/(?=(return t;)(?![\s\S]*\1))/, 
			function() {
				if (t.hasAttribute("opener")) {
					function shouldStack(tab) 
						let (args = tab.arguments) (args.aReferrerURI || args.aRelatedToCurrent && args.aURI != "about:blank");

					let lastRelatedTab = this.mCurrentTab;
					let isStack = lastRelatedTab.hasAttribute("group") && lastRelatedTab.getAttribute("group-counter") != 1;
					let willStack = (isStack || TU_getPref("extensions.tabutils.autoStack", false)) && shouldStack(t);
					if (isStack && !willStack)
						lastRelatedTab = this.lastSiblingTabOf(lastRelatedTab);

					if (TU_getPref("extensions.tabutils.openTabNext.keepOrder", true)) {
						let tab = lastRelatedTab.nextSibling;
						let panelId = this.mCurrentTab.linkedPanel;
						for (; tab && tab.pinned; tab = tab.nextSibling);
						for (; tab && tab.getAttribute("opener") == panelId && tab != t && (!willStack || shouldStack(tab)); tab = tab.nextSibling)
						lastRelatedTab = tab;
					}

					if (willStack)
						this.attachTabTo(t, lastRelatedTab, {move: true, expand: true});
					this.moveTabTo(t, t._tPos > lastRelatedTab._tPos ? lastRelatedTab._tPos + 1 : lastRelatedTab._tPos);
				}
			}
		]
	);

	TU_hookCode("gBrowser.onTabOpen", "}", 
		function() {
			if ((function() {
				switch (TU_getPref("extensions.tabutils.openTabNext", 1)) {
					case 1: //All
					case 2: return aRelatedToCurrent || aReferrerURI || aURI != "about:blank"; //All but New Tab
					case 3: return aRelatedToCurrent == null ? aReferrerURI : aRelatedToCurrent; //None but Links
					default: return false; //None
				}
			})()
			) {
				aTab.setAttribute("opener", this.mCurrentTab.linkedPanel);
			}
		}
	);

	TU_hookCode("gBrowser.onTabPinned", "}", 
		function() {
			aTab.removeAttribute("opener");
		}
	);

	//½ǩҳ
	if (BrowserOpenTab.name == "BrowserOpenTab") { //Compatibility with Speed Dial
		TU_hookCode("BrowserOpenTab",
			[/.*openUILinkIn\((.*)\)/, 
				function(s, s1) s.replace(s1, (
					s1 = s1.split(","),
					s1.push("{inBackground: TU_getPref('extensions.tabutils.loadNewInBackground', false)}"),
					s1.push("{relatedToCurrent: TU_getPref('extensions.tabutils.openTabNext', 1) == 1}"),
					s1.join().replace("},{", ",")
				))
			] // Bug 490225 [Fx11]
		);
	}
	TU_hookCode("isBlankPageURL", "aURL == BROWSER_NEW_TAB_URL", "$& && TU_getPref('extensions.tabutils.markNewAsBlank', true)");
	TU_hookCode("gBrowser._beginRemoveTab", /.*addTab.*/, "BrowserOpenTab();");
	TU_hookCode("gBrowser._endRemoveTab", /.*addTab.*/, "BrowserOpenTab();");

	gBrowser.getLastOpenedTab = function getLastOpenedTab() {
		return this.mTabContainer.getElementsByAttribute("linkedpanel", this.mPanelContainer.lastChild.id)[0];
	};

	//Ʊǩҳ
	TU_hookCode("gBrowser.duplicateTab",
		[/return/g, "var tab ="],
		["}", 
			function() {
				this.detachTab(tab, true);
				if (["_onDrop", "onxbldrop", "duplicateTabIn"].indexOf(arguments.callee.caller.name) == -1) {
					if (TU_getPref("extensions.tabutils.openDuplicateNext", true)) {
						if (aTab.hasAttribute("group") 
							&& aTab.getAttribute("group-counter") != 1 
							|| TU_getPref("extensions.tabutils.autoStack", false)
						)
							this.attachTabTo(tab, aTab, {move: true, expand: true});
						this.moveTabTo(tab, tab._tPos > aTab._tPos ? aTab._tPos + 1 : aTab._tPos);
					}
					if (!tabutils.gLoadAllInBackground && !TU_getPref("extensions.tabutils.loadDuplicateInBackground", false))
						this.selectedTab = tab;
				}
				return tab;
			}
		]
	);

	//رձǩҳ
	TU_hookCode("gBrowser.moveTabTo", "{", 
		function() {
			if (arguments.callee.caller.name == "ssi_undoCloseTab"
				&& !TU_getPref("extensions.tabutils.restoreOriginalPosition", true)
			)
				return;
		}
	);
};

// Tab Closing Options
//-----------------------------------------------
tabutils._tabClosingOptions = function() {

	//رձǩҳʱѡ/Ҳ/һ/һǩ
	gBrowser._tabsToSelect = function _tabsToSelect(aTab) {
		if (!aTab)
			aTab = this.mCurrentTab;

		var seenTabs = [];
		seenTabs[aTab._tPos] = true;

		var selectOnClose = TU_getPref("extensions.tabutils.selectOnClose", 0);
		if (selectOnClose & 0x80) for (let tab of _tabs_(0x80)) yield tab;
		if (selectOnClose & 0x40) for (let tab of _tabs_(0x40)) yield tab;
		if (selectOnClose & 0x20) for (let tab of _tabs_(0x20)) yield tab;
		if (selectOnClose & 0x03) for (let tab of _tabs_(selectOnClose & 0x03)) yield tab;
		if (selectOnClose & 0x1c) for (let tab of _tabs_(selectOnClose & 0x1c)) yield tab;

		function _tabs_(selectOnClose) {
			for (let tab of __tabs__(selectOnClose)) {
				if (!tab.hidden && !tab.closing && !(tab._tPos in seenTabs)) {
					seenTabs[tab._tPos] = true;
					yield tab;
				}
			}
		}

		function __tabs__(selectOnClose) {
			var tabs = gBrowser.mTabs;
			switch (selectOnClose) {
				case 1: //Left
					for (let i = aTab._tPos - 1; i >= 0; i--) yield tabs[i];
					break;
				case 2: //Right
					for (let i = aTab._tPos + 1; i < tabs.length; i++) yield tabs[i];
					break;
				case 4: //First
					for (let i = 0; i < tabs.length; i++) yield tabs[i];
					break;
				case 8: //Last
					for (let i = tabs.length - 1; i >= 0; i--) yield tabs[i];
					break;
				case 0x10: //Last selected
					var tabHistory = gBrowser.mTabContainer._tabHistory;
					for (let i = tabHistory.length - 1; i >= 0; i--) yield tabHistory[i];
					break;
				case 0x20: //Unread
					for (let tab of __tabs__()) if (tab.getAttribute("unread") == "true") yield tab;
					break;
				case 0x40: //Related
					for (let tab of __tabs__()) if (gBrowser.isRelatedTab(tab, aTab)) yield tab;
					break;
				case 0x80: //Unread Related
					for (let tab of __tabs__(0x20)) if (gBrowser.isRelatedTab(tab, aTab)) yield tab;
					break;
				case undefined: //Right or Rightmost
					for (let i = aTab._tPos + 1; i < tabs.length; i++) yield tabs[i];
					for (let i = aTab._tPos - 1; i >= 0; i--) yield tabs[i];
					break;
			}
		}
	};

	gBrowser._blurTab = function _blurTab(aTab) {
		if (!aTab.selected)
			return this.mCurrentTab;

		try {
			return this.selectedTab = this._tabsToSelect().next();
		}
		catch (e) {
			if (this.selectedTab = this.getLastSelectedTab())
				return this.selectedTab;

			if (this.selectedTab = this.getLastSelectedTab(1, true)) // Bug 633707, 651440, 654295, 654311, 663421
				return this.selectedTab;

			return this.selectedTab = BrowserOpenTab() || gBrowser.getLastOpenedTab();
		}
	};

	//رձǩҳʱѡǩ
	TU_hookCode("gBrowser.onTabSelect", "}", 
		function() {
			var panelId = aTab.linkedPanel;
			Array.forEach(this.mTabs, 
				function(aTab) {
					if (aTab.getAttribute("opener").startsWith(panelId))
						aTab.setAttribute("opener", panelId + (+aTab.getAttribute("opener").slice(panelId.length) + 1));
				}
			);
		}
	);

	TU_hookCode("gBrowser.onTabClose", "}", 
		function() {
			if (aTab.hasAttribute("opener")) {
				let opener = aTab.getAttribute("opener");
				let panelId = aTab.linkedPanel;
				Array.forEach(this.mTabs, 
					function(aTab) {
						if (aTab.getAttribute("opener").startsWith(panelId))
							aTab.setAttribute("opener", opener);
					}
				);
			}
		}
	);

	TU_hookCode("gBrowser.loadTabs", "}", 
		function() {
			if (aURIs.length > 1)
				this.updateCurrentBrowser(true);
		}
	);

	gBrowser.isRelatedTab = function isRelatedTab(aTab, bTab) {
		if (!bTab)
			bTab = this.mCurrentTab;

		return aTab.hasAttribute("opener") && aTab.getAttribute("opener") == bTab.getAttribute("opener")
			|| aTab.getAttribute("opener").startsWith(bTab.linkedPanel)
			|| bTab.getAttribute("opener").startsWith(aTab.linkedPanel);
	};

	//رձǩҳʱѡϴıǩ
	gBrowser.mTabContainer._tabHistory = Array.slice(gBrowser.mTabs);
	TU_hookCode("gBrowser.onTabOpen", "}", 
		function() {
			var tabHistory = this.mTabContainer._tabHistory;
			if (aTab.hasAttribute("opener")) {
				let index = tabHistory.lastIndexOf(this.mCurrentTab);
				while (index > 0 && tabHistory[index - 1].getAttribute("opener") == aTab.getAttribute("opener"))
					index--;
				tabHistory.splice(index, 0, aTab);
			}
			else
				tabHistory.unshift(aTab);
		}
	);

	TU_hookCode("gBrowser.onTabSelect", "}", 
		function() {
			var tabHistory = this.mTabContainer._tabHistory;
			tabHistory.splice(tabHistory.lastIndexOf(aTab), 1);
			tabHistory.push(aTab);
		}
	);

	TU_hookCode("gBrowser.onTabClose", "}", 
		function() {
			var tabHistory = this.mTabContainer._tabHistory;
			tabHistory.splice(tabHistory.lastIndexOf(aTab), 1);
		}
	);

	gBrowser.getLastSelectedTab = function getLastSelectedTab(aDir, aIgnoreHidden) {
		var tabHistory = this.mTabContainer._tabHistory;
		var index = tabHistory.lastIndexOf(this.mCurrentTab);
		for (var i = (index > -1); i < tabHistory.length; i++) {
			var tab = tabHistory[index = aDir < 0 ? index + 1 : index - 1]
				|| tabHistory[index = aDir < 0 ? 0 : tabHistory.length - 1];
			if ((aIgnoreHidden || !tab.hidden) && !tab.closing)
				return tab;
		}
	};

	//Ctrl+Tabлϴıǩ
	//Ctrl+ҷлǰһ/һǩ
	tabutils.addEventListener(window, "keypress", 
		function(event) {
			if (!event.ctrlKey || event.altKey || event.metaKey)
				return;

			switch (true) {
				case event.keyCode == event.DOM_VK_TAB:
					if (TU_getPref("extensions.tabutils.handleCtrlTab", true)) {
						if (!gBrowser._previewMode && TU_getPref("extensions.tabutils.handleCtrl", true))
							gBrowser._previewMode = true;

						gBrowser.selectedTab = gBrowser.getLastSelectedTab(event.shiftKey ? -1 : 1);
						event.preventDefault();
						event.stopPropagation();
					}
					break;
				case event.keyCode == event.DOM_VK_LEFT && !event.shiftKey:
				case event.keyCode == event.DOM_VK_RIGHT && !event.shiftKey:
					if (TU_getPref("extensions.tabutils.handleCtrlArrow", true)) {
						if (!gBrowser._previewMode && TU_getPref("extensions.tabutils.handleCtrl", true))
							gBrowser._previewMode = true;

						let rtl = getComputedStyle(gBrowser.mTabContainer).direction == "rtl";
						gBrowser.mTabContainer.advanceSelectedTab(event.keyCode == event.DOM_VK_LEFT ^ rtl ? -1 : 1, true);
						event.preventDefault();
						event.stopPropagation();
						}
					break;
				case event.keyCode == event.DOM_VK_PAGE_UP && !event.shiftKey:
				case event.keyCode == event.DOM_VK_PAGE_DOWN && !event.shiftKey:
					if (!gBrowser._previewMode && TU_getPref("extensions.tabutils.handleCtrl", true))
					gBrowser._previewMode = true;
					break;
			}
		}
	, true);

	tabutils.addEventListener(window, "keyup", 
		function(event) {
			switch (event.keyCode) {
				case event.DOM_VK_CONTROL:
					if (gBrowser._previewMode) {
						gBrowser._previewMode = false;
						gBrowser.updateCurrentBrowser(true);
					}
					break;
				case event.DOM_VK_LEFT:
				case event.DOM_VK_RIGHT:
					if (event.ctrlKey && TU_getPref("extensions.tabutils.handleCtrlArrow", true))
						event.stopPropagation();
			}
		}
	, true);

	tabutils.addEventListener(window, "keydown", 
		function(event) {
			switch (event.keyCode) {
				case event.DOM_VK_LEFT:
				case event.DOM_VK_RIGHT:
					if (event.ctrlKey && TU_getPref("extensions.tabutils.handleCtrlArrow", true))
						event.stopPropagation();
			}
		}
	, true);

	TU_hookCode("gBrowser.onTabClose", "}", 
		function() {
			if (gBrowser._previewMode) {
				gBrowser.selectedTab = let (tabHistory = gBrowser.mTabContainer._tabHistory) tabHistory[tabHistory.length - 1];
				gBrowser._previewMode = false;
			}
		}
	);

	TU_hookCode("gBrowser.updateCurrentBrowser", /.*dispatchEvent[\s\S]*_tabAttrModified.*/, 
		"$&};if (window.windowState != window.STATE_MINIMIZED) {");

	//Don't close the last primary window with the las tab
	TU_hookCode("gBrowser._beginRemoveTab", "_closeWindowWithLastTab", "$& && " + (
		function() { //Bug 607893
			(TU_getPref("extensions.tabutils.closeLastWindowWithLastTab", false) || 
				function() {
					var winEnum = Services.wm.getEnumerator("navigator:browser");
					while (winEnum.hasMoreElements()) {
						var win = winEnum.getNext();
						if (win != window && win.toolbar.visible)
							return win;
					}
				}()
			)
		}
	).toString().replace(/^.*{|}$/g, ""));

	//Don't resize tabs until mouse leaves the tab bar
	gBrowser.mTabContainer.__defineGetter__("_tabSizingRule", 
		function() { //Bug 465086, 649654
			delete this._tabSizingRule;
			return this._tabSizingRule = tabutils.insertRule('.tabbrowser-tabs[dontresize] > .tabbrowser-tab:not([pinned]):not([faviconized]) {}');
		}
	);

	gBrowser.mTabContainer._lockTabSizing = function() {};
	gBrowser.mTabContainer._unlockTabSizing = function() {};

	gBrowser.mTabContainer._revertTabSizing = function _revertTabSizing() {
		if (!this._tabSizingLocked)
			return;

		if (this._tabSizingLocked == 1) {
			this._tabSizingLocked = false;
			return;
		}

		this.mTabstrip._scrollbox.style.maxWidth = "";
		this._closingTabsSpacer.style.minWidth = "";
		this.removeAttribute("dontresize");
		this._tabSizingLocked = false;

		if (this.hasAttribute("overflow") && this.mTabstrip._scrollbox.scrollWidth <= this.mTabstrip._scrollbox.clientWidth) {
			this.mTabstrip._scrollButtonUp.style.visibility = "";
			this.mTabstrip._scrollButtonDown.style.visibility = "";
			this.removeAttribute("overflow");
		}
		this.adjustTabstrip();
		this._fillTrailingGap();
	};

	tabutils.addEventListener(gBrowser.mTabContainer, 'mouseover', 
		function(event) {
			if (this._tabSizingLocked || this.hasAttribute("multirow") || this.orient == "vertical"
				|| event.target.localName != "tab" || event.target.pinned
				|| !TU_getPref("extensions.tabutils.delayResizing", true)
			)
				return;

			this._tabSizingLocked = true;
			window.addEventListener('mousemove', 
				function(event) {
					let boxObject = gBrowser.mTabContainer.boxObject;
					if (event.screenY < boxObject.screenY - boxObject.height * 0.5 
						|| event.screenY > boxObject.screenY + boxObject.height * 1.5
					) {
						window.removeEventListener('mousemove', arguments.callee, false);
						gBrowser.mTabContainer._revertTabSizing();
					}
				}
			, false);
		}
	, false);

	tabutils.addEventListener(gBrowser.mTabContainer, 'TabClose', 
		function(event) {
			if (!this._tabSizingLocked || event.target.pinned)
				return;

			if (this._tabSizingLocked == 1) {
				this.mTabstrip._scrollbox.style.maxWidth = this.mTabstrip._scrollbox.clientWidth + "px";
				this._tabSizingLocked++;
			}

			let tab = event.target;
			let visibleTabs = Array.filter(this.childNodes, function(aTab) aTab.boxObject.width > 0);
			let flexibleTabs = Array.filter(visibleTabs, function(aTab) getComputedStyle(aTab).MozBoxFlex > 0);
			if (flexibleTabs.length == 0)
				return;

			if (tab == visibleTabs[visibleTabs.length - 1] || tab == flexibleTabs[flexibleTabs.length - 1]) {
				if (this.hasAttribute("dontresize")) {
					let spacer = this._closingTabsSpacer;
					spacer.style.MozBoxFlex = 1;
					spacer.style.minWidth = getComputedStyle(spacer).width;
					spacer.style.MozBoxFlex = "";

					this.setAttribute("dontanimate", true);
					this.removeAttribute("dontresize");this.clientTop; //Bug 649247
					this.setAttribute("dontanimate", !TU_getPref("browser.tabs.animate"));
				}
				return;
			}

			if (!this.hasAttribute("dontresize")) {
				let width = flexibleTabs[0].getBoundingClientRect().width;
				this._tabSizingRule.style.setProperty("max-width", width + "px", "important");

				this.setAttribute("dontanimate", true);
				this.setAttribute("dontresize", true);this.clientTop;
				this.setAttribute("dontanimate", !TU_getPref("browser.tabs.animate"));
			}

			if (!this.mTabstrip._scrollButtonUp.disabled) {
				let spacer = this._closingTabsSpacer;
				let width = parseFloat(spacer.style.minWidth) || 0;
				width += tab.getBoundingClientRect().width;

				if (!this.mTabstrip._scrollButtonDown.disabled) {
					let scrollbox = this.mTabstrip._scrollbox;
					width -= scrollbox.scrollLeftMax - scrollbox.scrollLeft; // Bug 766937 [Fx16]
				}
				spacer.style.minWidth = width + "px";
			}
		}
	, false);

	tabutils.addEventListener(gBrowser.mTabContainer, 'TabOpen', 
		function(event) {
			if (this._tabSizingLocked)
				this._revertTabSizing();
		}
	, false);

	tabutils.addEventListener(gBrowser.mTabContainer, 'underflow', 
		function(event) {
			if (this._tabSizingLocked > 1) {
				this.setAttribute("overflow", true);
				this.mTabstrip._scrollButtonUp.style.visibility = "visible";
				this.mTabstrip._scrollButtonDown.style.visibility = "visible";
			}
		}
	, false);
};


// Tab Clicking Options
//-----------------------------------------------
tabutils._tabClickingOptions = function() {

	//URL
	gBrowser.loadURLFromClipboard = function loadURLFromClipboard(aTab) {
		var url = readFromClipboard();
		if (!url)
			return;

		if (aTab) {
			aTab.linkedBrowser.stop();
			aTab.linkedBrowser.loadURIWithFlags(url, Ci.nsIWebNavigation.LOAD_FLAGS_ALLOW_THIRD_PARTY_FIXUP);
		}
		else {
			this.loadOneTab(url, null, null, null, TU_getPref('extensions.tabutils.loadNewInBackground', false), true);
		}
	};

	//ʷ˵
	TU_hookCode("FillHistoryMenu",
		["count <= 1", "count == 0"],
		[/(?=var webNav)/, 
			function() {
				var tab = document.popupNode;
				if (!tab || tab.localName != 'tab')
					tab = gBrowser.selectedTab;
				aParent.value = tab._tPos;
			}
		],
		["gBrowser.webNavigation", "tab.linkedBrowser.webNavigation"]
	);
	TU_hookCode("gotoHistoryIndex",
		["gBrowser.selectedTab", "tab", "g"],
		["gBrowser", "tab.linkedBrowser", "g"],
		[/(?=let where)/, "let tab = gBrowser.mTabs[aEvent.target.parentNode.value];"]
	);

	TU_hookCode("TabContextMenu.updateContextMenu", "aPopupMenu.triggerNode", "document.popupNode", "g");
	TU_hookCode("gBrowser.mTabContainer._selectNewTab", "{", 
		function() {
			if (
				["onxblmousedown"].indexOf(arguments.callee.caller.name) > -1 
				&& !aNewTab.selected
			)
				aNewTab.setAttribute("firstclick", true);
		}
	);

	gBrowser.onTabClick = function onTabClick(event) {
		if (event.target.hasAttribute("firstclick")) {
			event.target.removeAttribute("firstclick");
			if (event.button == 0 && !event.ctrlKey && !event.altKey && !event.shiftKey && !event.metaKey)
				return;
		}

		if (event.altKey) {
			window.addEventListener("keyup", 
				function(event) {
					if (event.keyCode == event.DOM_VK_ALT) {
						window.removeEventListener("keyup", arguments.callee, true);
						event.preventDefault();
						event.stopPropagation();
					}
				}
				, true
			);
		}

		var type = [
			event.ctrlKey || event.metaKey ? "Ctrl" : "",
			event.altKey ? "Alt" : "",
			event.shiftKey ? "Shift" : "",
			event.button == 1 ? "Middle" : event.button == 2 ? "Right" : ""
		].join("").replace(/./, function(s) s.toLowerCase());

		if (type) {
			this.doClickAction(type, event);
		}
		else if (event.detail == 1 && !event.target.mOverCloseButton) {
			event.target._leftClickTimer = setTimeout(
				function(self) {
				self.doClickAction("left", event);
				}
			, TU_getPref("extensions.tabutils.leftClickTabDelay", 250), this);
		}
	};

	gBrowser.onTabBarDblClick = function onTabBarDblClick(event) {
		if (event.button == 0 && !event.ctrlKey && !event.altKey && !event.shiftKey && !event.metaKey
			&& !this._blockDblClick && !gBrowser._blockDblClick) 
		{
			clearTimeout(event.target._leftClickTimer);
			this.doClickAction("dbl", event);
		}
	};

	gBrowser._getTargetTab = function _getTargetTab(event) {
		if (event.target.localName == "tab")
			return event.target;

		for (let target = event.originalTarget; target; target = target.parentNode) {
			switch (target.localName) {
				case "tab":
				case "tabs": return target;
				case "menuitem": return target.tab;
				case "toolbarbutton": return target.command == "cmd_newNavigatorTab" ? target : null;
			}
		}
		return null;
	};

	gBrowser.doClickAction = function doClickAction(type, event) {
		var target = this._getTargetTab(event);
		if (!target)
			return;

		TabContextMenu.contextTab = target.localName == "tab" ? target : gBrowser.mCurrentTab;
		gBrowser.mContextTabs = gBrowser.contextTabsOf(gBrowser.mContextTab);

		var prefName = target.localName == "tab" ? "ClickTab" :
		   target.localName == "tabs" ? "ClickTabBar" : "ClickNewTabButton";
		var action = TU_getPref("extensions.tabutils." + type + prefName, 0);
		var code = TU_getPref("extensions.tabutils.mouse." + action + ".oncommand");
		if (code) {
			try {
				new Function("event", code)(event);
			}
			catch (e) {}

			event.preventDefault();
			event.stopPropagation();
			return;
		}

		function $() document.getElementById.apply(document, arguments);

		switch (action) {
			case 0: //Default
				return;
			case 1: //New Tab
				BrowserOpenTab();
				break;
			case 2: //Duplicate Tab
				$("context_duplicateTab").doCommand();
				break;
			case 3: //Reload Tab
				$("context_reloadTab").doCommand();
				break;
			case 4: //Close Tab
				$("context_closeTab").doCommand();
				break;
			case 5: //Undo Close Tab
				undoCloseTab();
				break;
			case 6: //Load URL from Clipboard
				gBrowser.loadURLFromClipboard(target.localName == "tab" ? gBrowser.mContextTab : null);
				break;
			case 7: //Switch to Last Selected Tab
				if (gBrowser.mContextTab.selected) {
					gBrowser.selectedTab = gBrowser.getLastSelectedTab();
				}
				break;
			case 11: //Session History Menu
				var backForwardMenu = $("backForwardMenu");
				document.popupNode = gBrowser.mContextTab;
				backForwardMenu.setAttribute("onpopuphidden", "if (event.target == this) document.popupNode = null;");
				backForwardMenu.openPopupAtScreen(event.screenX, event.screenY, true);
				break;
			case 12: //Recently Closed Tabs
				$("undoCloseTabPopup").openPopupAtScreen(event.screenX, event.screenY, true);
				break;
			case 13: //List All Tabs
				var allTabsPopup = gBrowser.mTabContainer.mAllTabsPopup;
				if (allTabsPopup) {
					allTabsPopup.openPopupAtScreen(event.screenX, event.screenY, true);
				}
			break;
			case 14: //Tab Context Menu
				var tabContextMenu = gBrowser.tabContextMenu;
				document.popupNode = gBrowser.mContextTab;
				tabContextMenu.setAttribute("onpopuphidden", "if (event.target == this) document.popupNode = null;");
				tabContextMenu.openPopupAtScreen(event.screenX, event.screenY, true);
				break;
			case 16: //Toolbar Context Menu
				$("toolbar-context-menu").openPopupAtScreen(event.screenX, event.screenY, true);
				break;
			case 15: //Bookmarks
				$("bookmarksPopup").openPopupAtScreen(event.screenX, event.screenY, false);
				break;
			case 21: //Protect Tab
				$("context_protectTab").doCommand();
				break;
			case 22: //Lock Tab
				$("context_lockTab").doCommand();
				break;
			case 23: //Freeze Tab
				gBrowser.freezeTab(gBrowser.mContextTabs);
				break;
			case 24: //Faviconize Tab
				$("context_faviconizeTab").doCommand();
				break;
			case 25: //Pin Tab
				gBrowser.pinTab(gBrowser.mContextTabs);
				break;
			case 26: //Hide Tab
				break;
			case 27: //Rename Tab
				$("context_renameTab").doCommand();
				break;
			case 28: //Restart Tab
				$("context_restartTab").doCommand();
				break;
			case 29: //Reload Tab Every
				$("context_reloadEvery").getElementsByAttribute("anonid", "enable")[0].doCommand();
				break;
			case 31: //Select a Tab
				$("context_selectTab").doCommand();
				break;
			case 32: //Select Multiple Tabs
				$("context_selectTabs").doCommand();
				break;
			case 33: //Select Multiple Tabs (+)
				gBrowser.selectTabs(gBrowser.mContextTab, true);
				break;
			case 34: //Select All Tabs
				$("context_selectAllTabs").doCommand();
				break;
			case 35: //Unselect All Tabs
				$("context_unselectAllTabs").doCommand();
				break;
			case 36: //Invert Selection
				$("context_invertSelection").doCommand();
				break;
			case 37: //Select Similar Tabs
				gBrowser.selectedTabs = gBrowser.similarTabsOf(gBrowser.mContextTabs);
				break;
			case 41: //Close Left Tabs
				$("context_closeLeftTabs").doCommand();
				break;
			case 42: //Close Right Tabs
				$("context_closeRightTabs").doCommand();
				break;
			case 43: //Close Other Tabs
				$("context_closeOtherTabs").doCommand();
				break;
			case 44: //Close Duplicate Tabs
				$("context_closeDuplicateTabs").doCommand();
				break;
			case 45: //Close Similar Tabs
				$("context_closeSimilarTabs").doCommand();
				break;
			case 46: //Close All Tabs
				$("context_closeAllTabs").doCommand();
				break;
			case 51: //Collapse/Expand Stack
				if (gBrowser.mContextTab.getAttribute("group-collapsed") == "true")
					$("context_expandGroup").doCommand();
				else
					$("context_collapseGroup").doCommand();
				break;
			case 52: //Recolor Stack
				$("context_colorGroup").doCommand();
				break;
			default: //Do Nothing
				break;
		}

		event.preventDefault();
		event.stopPropagation();
	};

	gBrowser.mTabContainer.setAttribute("onclick", "if (event.button == 0) gBrowser.onTabClick(event);");
	gBrowser.mTabContainer.setAttribute("ondblclick", "gBrowser.onTabBarDblClick(event);");
	tabutils.addEventListener(gBrowser.mTabContainer, "MozMouseHittest", 
		function(event) {
			if (event.ctrlKey || event.altKey || event.shiftKey || event.metaKey || event.detail > 0) 
				event.stopPropagation();
		}
		, true
	);
	tabutils.addEventListener(gBrowser.mTabContainer, "click", 
		function(event) {
			if (event.button == 1) 
				gBrowser.onTabClick(event);
		}
		, true
	);
	tabutils.addEventListener(gBrowser.mTabContainer, "contextmenu", 
		function(event) {
			if (event.button == 2) 
				gBrowser.onTabClick(event);
		}
		, true
	);
	tabutils.addEventListener(gBrowser.mTabContainer, "dblclick", 
		function(event) {
			if (event.target.localName == "tabs") 
				gBrowser.onTabBarDblClick(event);
		}
		, true
	);

	//Mouse release to select
	TU_hookCode("gBrowser.mTabContainer._selectNewTab", "{", 
		function() {
			if (
				["onxblmousedown"].indexOf(arguments.callee.caller.name) > -1 
				&& TU_getPref("extensions.tabutils.mouseReleaseSelect", true)
			)
				return;
		}
	);

	TU_hookCode("gBrowser.onTabClick", "{", 
		function() {
			if (event.button == 0 && !event.ctrlKey && !event.altKey && !event.shiftKey && !event.metaKey &&
				event.target.localName == "tab" && !event.target.mOverCloseButton
			) {
				if (!event.target.selected) {
					this.mTabContainer._selectNewTab(event.target);
					return;
				}
				if (gBrowser._previewMode) {
					gBrowser._previewMode = false;
					gBrowser.updateCurrentBrowser(true);
					return;
				}
			}
		}
	);

	//Mouse scroll to select
	tabutils.addEventListener(gBrowser.mTabContainer, 'DOMMouseScroll', 
		function(event) {
			if (event.ctrlKey) {
				document.getElementById(event.detail < 0 ? "cmd_prevGroup" : "cmd_nextGroup").doCommand();
				event.stopPropagation();
				return;
			}

			if (event.target.localName == "tab" && TU_getPref("extensions.tabutils.mouseHoverPreview", true)) {
				goDoCommand(event.detail < 0 ? "cmd_scrollLineUp" : "cmd_scrollLineDown");
				event.stopPropagation();
				return;
			}

			if (
				event.originalTarget != this.mTabstrip._scrollButtonUp &&
				event.originalTarget != this.mTabstrip._scrollButtonDown &&
				TU_getPref("extensions.tabutils.mouseScrollSelect", false)
			) {
				let scrollDir = event.detail < 0 ^ TU_getPref("extensions.tabutils.mouseScrollSelectDir", false) ? -1 : 1;
				this.advanceSelectedTab(scrollDir, TU_getPref("extensions.tabutils.mouseScrollSelectWrap", false));
				event.stopPropagation();
			}
		}
		, true
	);

	//Center current tab
	TU_hookCode("gBrowser.onTabSelect", "}", 
		function() {
			if (TU_getPref("extensions.tabutils.centerCurrentTab", false)) {
				let tabStrip = this.mTabContainer.mTabstrip;
				let scrollRect = tabStrip.scrollClientRect;
				let tabRect = aTab.getBoundingClientRect();
				let [start, end] = tabStrip._startEndProps;
				tabStrip._stopSmoothScroll();
				tabStrip.scrollPosition += (tabRect[start] + tabRect[end])/2 - (scrollRect[start] + scrollRect[end])/2;
			}
		}
	);
};
