
// Preview Tab
//-----------------------------------------------
tabutils._previewTab = function() {
	tabutils.addEventListener(gBrowser.mTabContainer, 'mouseover', 
		function(event) {
			if (event.target.localName == 'tab' && !event.target.selected && TU_getPref("extensions.tabutils.mouseHoverPreview", false)) {
				let tab = event.target;
				let target = event.relatedTarget;
				while (target && target != tab)
					target = target.parentNode;
				if (target)
					return;

				clearTimeout(this._mouseHoverPreviewTimer);
				this._mouseHoverPreviewTimer = setTimeout(
					function(self) {
						if (!tab.selected) {
							gBrowser._previewMode = true;
							gBrowser.selectedTab = tab;
							if (tab.hasAttribute("pending") && TU_getPref("extensions.tabutils.mouseHoverLoad", false))
								gBrowser.reloadTab(tab);
							if (TU_getPref("extensions.tabutils.mouseHoverSelect", false)) {
								self._mouseHoverPreviewTimer = setTimeout(
									function() {
										gBrowser._previewMode = false;
										gBrowser.updateCurrentBrowser(true);
									}
									, TU_getPref("extensions.tabutils.mouseHoverSelectDelay", 750)
								);
							}
						}
					}
					, TU_getPref("extensions.tabutils.mouseHoverPreviewDelay", 250), this
				);
			}
		}
	, false);

	tabutils.addEventListener(gBrowser.mTabContainer, 'mouseout', 
		function(event) {
			if (event.target.localName == 'tab') {
				let tab = event.target;
				let target = event.relatedTarget;
				while (target && target != tab)
					target = target.parentNode;
				if (target)
					return;

				clearTimeout(this._mouseHoverPreviewTimer);
				if (!gBrowser._previewMode)
					return;

				this._mouseHoverPreviewTimer = setTimeout(
					function() {
						gBrowser.selectedTab = let (tabHistory = gBrowser.mTabContainer._tabHistory) tabHistory[tabHistory.length - 1];
						gBrowser._previewMode = false;
					}
					, TU_getPref("extensions.tabutils.mouseHoverPreviewDelay", 250)
				);
			}
		}
	, false);

	tabutils.onDOMMenuItemActive = function onDOMMenuItemActive(event) {
		let popup = event.target.parentNode;
		let tab = event.target.tab || gBrowser.mTabs[event.target.value];
		if (tab && TU_getPref("extensions.tabutils.mouseHoverPreview", false)) {
			clearTimeout(popup._mouseHoverPreviewTimer);
			popup._mouseHoverPreviewTimer = setTimeout(
				function() {
					gBrowser._previewMode = true;
					gBrowser.selectedTab = tab;
					if (tab.hasAttribute("pending") && TU_getPref("extensions.tabutils.mouseHoverLoad", false))
						gBrowser.reloadTab(tab);
				}
				, TU_getPref("extensions.tabutils.mouseHoverPreviewDelay", 250)
			);
		}
	};

	tabutils.onDOMMenuItemInactive = function onDOMMenuItemInactive(event) {
		let popup = event.target.parentNode;
		let tab = event.target.tab || gBrowser.mTabs[event.target.value];
		if (tab) {
			clearTimeout(popup._mouseHoverPreviewTimer);
			if (!gBrowser._previewMode)
			return;

			popup._mouseHoverPreviewTimer = setTimeout(
				function() {
					gBrowser.selectedTab = let (tabHistory = gBrowser.mTabContainer._tabHistory) tabHistory[tabHistory.length - 1];
					gBrowser._previewMode = false;
				}
				, TU_getPref("extensions.tabutils.mouseHoverPreviewDelay", 250)
			);
		}
	};

	tabutils.onMenuItemCommand = function onMenuItemCommand(event) {
		let tab = event.target.tab || gBrowser.mTabs[event.target.value];
		if (tab && gBrowser._previewMode) {
			gBrowser._previewMode = false;
			gBrowser.updateCurrentBrowser(true);
		}
	};

	tabutils.onMenuItemMouseScroll = function onMenuItemMouseScroll(event) {
		let tab = event.target.tab || gBrowser.mTabs[event.target.value];
		if (tab && TU_getPref("extensions.tabutils.mouseHoverPreview", true)) {
			goDoCommand(event.detail < 0 ? "cmd_scrollLineUp" : "cmd_scrollLineDown");
			event.stopPropagation();
		}
	};

	let allTabsPopup = document.getElementById("nav-bar")._getToolbarItem("alltabs-button")
		.getElementsByAttribute("id", "alltabs-popup")[0];
	tabutils.addEventListener(allTabsPopup, "DOMMenuItemActive", tabutils.onDOMMenuItemActive, false);
	tabutils.addEventListener(allTabsPopup, "DOMMenuItemInactive", tabutils.onDOMMenuItemInactive, false);
	tabutils.addEventListener(allTabsPopup, "DOMMouseScroll", tabutils.onMenuItemMouseScroll, true);
	tabutils.addEventListener(allTabsPopup, "command", tabutils.onMenuItemCommand, true);

	let tabStackPopup = document.getElementById("tabStackPopup");
	tabutils.addEventListener(tabStackPopup, "DOMMenuItemActive", tabutils.onDOMMenuItemActive, false);
	tabutils.addEventListener(tabStackPopup, "DOMMenuItemInactive", tabutils.onDOMMenuItemInactive, false);
	tabutils.addEventListener(tabStackPopup, "DOMMouseScroll", tabutils.onMenuItemMouseScroll, true);
	tabutils.addEventListener(tabStackPopup, "command", tabutils.onMenuItemCommand, true);
};
