// first Run
//-----------------------------------------------
tabutils._firstRun = function() {
	if (TU_getPref("extensions.tabutils.firstRun"))
		return;
	TU_setPref("extensions.tabutils.firstRun", true);

	let navbar = document.getElementById("nav-bar");
	navbar.currentSet = navbar.currentSet.replace(/undoclosetab-button|button_tuOptions/g, "")
		.replace("urlbar-container", "undoclosetab-button,button_tuOptions,$&");
	navbar.setAttribute("currentset", navbar.currentSet);
	document.persist(navbar.id, "currentset");
};

//---------------------------------------------------------------------------------------------
// Some Event Listener stuff
//---------------------------------------------------------------------------------------------

// Unread Tab Hooks
//-----------------------------------------------
//δǩҳ
tabutils._unreadTab = function() {
	gBrowser.unreadTab = function unreadTab(aTab, aForce) {
		if (aForce == null)
			aForce = aTab.getAttribute("unread") != "true";

		if (aForce && !aTab.selected) {
			tabutils.setAttribute(aTab, "unread", true);
			aTab.setAttribute("rotate", aTab.getAttribute("rotate") != "true");
		}
		else {
			tabutils.removeAttribute(aTab, "unread");
			aTab.removeAttribute("rotate");
		}
	};

	TU_hookCode("gBrowser.onTabRestoring", "}", 
		function() {
			this.unreadTab(aTab, ss.getTabValue(aTab, "unread") == "true");
		}
	);

	TU_hookCode("gBrowser.onTabOpen", "}", 
		function() {
			this.unreadTab(aTab, true);
		}
	);

	TU_hookCode("gBrowser.onTabSelect", "}", 
		function() {
			this.unreadTab(aTab, false);
		}
	);

	TU_hookCode("gBrowser.setTabTitle", /(?=aTab.label = title;)/, 
		function() {
			if (!aTab.hasAttribute("busy") && !aTab.linkedBrowser.__SS_restoreState)
				this.unreadTab(aTab, true);
		}
	);

	TU_hookCode("gBrowser.mTabProgressListener", 'this.mTab.setAttribute("unread", "true");', 
		function() {
			if (!this.mBrowser.__SS_restoreState)
				this.mTabBrowser.unreadTab(this.mTab, true);
		}
	);
}


// Hide Tab Bar
//-----------------------------------------------
tabutils._hideTabBar = function() {
	if (onViewToolbarsPopupShowing.name == "onViewToolbarsPopupShowing") //Compa. with Omnibar
		TU_hookCode("onViewToolbarsPopupShowing", /(?=.*addon-bar.*)/, 
			function() {
				let tabsToolbar = document.getElementById("TabsToolbar");
				if (toolbarNodes.indexOf(tabsToolbar) == -1)
					toolbarNodes.push(tabsToolbar);
			}
		);

	TU_hookCode("setToolbarVisibility", /.*setAttribute.*/, 
		'if (toolbar.id == "TabsToolbar") gBrowser.mTabContainer.visible = isVisible; else $&');
	TU_hookCode("gBrowser.mTabContainer.updateVisibility", "{", 
		'if (!TU_getPref("browser.tabs.autoHide")) return;');
};


// Tab Misc Features
//-----------------------------------------------
tabutils._miscFeatures = function() {
	TU_hookCode("gBrowser.onTabOpen", "}", 
		function() { //Bug 615039
			TU_hookCode.call(aTab.linkedBrowser, "loadURIWithFlags", "{", 
				function() {
					try {
						makeURI(aURI);
					}
					catch (e) {
						try {
							if (
								aURI && aURI.indexOf(".") == -1
								&& aFlags & Ci.nsIWebNavigation.LOAD_FLAGS_ALLOW_THIRD_PARTY_FIXUP
								&& TU_getPref("keyword.enabled")
								&& TU_getPref("network.dns.ignoreHostonly", false)
							)
								aURI = tabutils._URIFixup.keywordToURI(aURI).spec;
						}
						catch (e) {}
					}
				}
			);
		}
	);

	if ("TreeStyleTabBrowser" in window) //Compatibility with Tree Style Tab
		TU_hookCode("TreeStyleTabBrowser.prototype.positionPinnedTabs", "{", "return;");

	if ("openGMarkLabelInTabs" in window) //Compatibility with GMarks
		TU_hookCode("openGMarkLabelInTabs",
			[/.*openUILinkIn.*/, ""],
			[/(?=.*(labelArray)(?![\s\S]*\1))/, 
				function() {
					var urls = [label.url for (label of labelArray)];
					var loadInBackground = TU_getPref("browser.tabs.loadBookmarksInBackground");
					gBrowser.loadTabs(urls, loadInBackground, false);
				}
			]
		);

	/*  TU_hookCode("PlacesStarButton._updateStateInternal", /(?=.*this._itemIds.*)/, function() { //Bug 650527
	this._itemIds = this._itemIds.filter(function(itemId) {
	var parentId = PlacesUtils.bookmarks.getFolderIdForItem(itemId);
	var grandparentId = PlacesUtils.bookmarks.getFolderIdForItem(parentId);
	return grandparentId != PlacesUtils.tagsFolderId;
	});
	});*/

	//Compatibility with themes
	let os = Services.appinfo.OS; //WINNT, Linux or Darwin
	let version = parseFloat(Services.appinfo.version);
	document.documentElement.setAttribute("OS", os);
	document.documentElement.setAttribute("v4", version >= 4.0);
	document.documentElement.setAttribute("v6", version >= 6.0);
	document.documentElement.setAttribute("v14", version >= 14.0);
	document.documentElement.setAttribute("v24", version >= 24.0);

	for (let i = 0, styleSheet; styleSheet = document.styleSheets[i]; i++) {
		switch (styleSheet.href) {
			case "chrome://browser/skin/browser.css":
				for (let j = 0, cssRule; cssRule = styleSheet.cssRules[j]; j++) {
					if (/> .tabbrowser-tab/.test(cssRule.selectorText)) {
						tabutils.insertRule(cssRule.cssText.replace(RegExp.lastMatch, ".tabbrowser-tab"));
						continue;
					}

					if (/> .tabbrowser-arrowscrollbox > .arrowscrollbox-scrollbox/.test(cssRule.selectorText)) {
						tabutils.insertRule(cssRule.cssText.replace(RegExp.lastMatch, "#PinnedTabsBarItems"));
						continue;
					}

					switch (cssRule.selectorText) {
						case ".tabbrowser-arrowscrollbox > .arrowscrollbox-scrollbox":
							tabutils.insertRule(cssRule.cssText.replace(cssRule.selectorText, ".tabbrowser-tabs[orient='horizontal']:not([overflow]):not([multirow]) $&"))
							.style.MozMarginStart = "-" + cssRule.style.MozPaddingStart;
							tabutils.insertRule(cssRule.cssText.replace(cssRule.selectorText, "#PinnedTabsBarItems"));
							tabutils.insertRule(cssRule.cssText.replace(cssRule.selectorText, ".tabbrowser-tabs[orient='horizontal']:not([overflow]):not([multirow]) #PinnedTabsBarItems"))
							.style.MozMarginEnd = "-" + cssRule.style.MozPaddingEnd;
							break;
						case ".tab-throbber[pinned], .tab-icon-image[pinned]":
						case ".tab-throbber[pinned], .tab-icon-image[pinned], .tabs-newtab-button > .toolbarbutton-icon":
							tabutils.insertRule(cssRule.cssText.replace(cssRule.selectorText, ".tabbrowser-tab[faviconized] :-moz-any(.tab-throbber, .tab-icon-image)"));
							break;
					}
				}
				break;
			case "chrome://clrtabs/skin/prefs.css": // Compat. with ColorfulTabs 17.2
				for (let j = 0, cssRule; cssRule = styleSheet.cssRules[j]; j++) {
					switch (cssRule.selectorText) {
						case "tab.tabbrowser-tab .tab-text.tab-label":
							cssRule.style.setProperty("color", cssRule.style.getPropertyValue("color"), "");
							break;
					}
				}
				break;
		}
	}
};
